<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

//if ( !class_exists('NNRobots_Optin_Fire_Admin_Functions') ) :

// Load stats and emails

add_action( 'wp_ajax_nnr_of_stats_load', 					array('NNRobots_Optin_Fire_Admin_Functions', 'stats_load'));
add_action( 'wp_ajax_nnr_of_emails_load', 					array('NNRobots_Optin_Fire_Admin_Functions', 'emails_load'));
add_action( 'wp_ajax_nnr_of_entries_load', 					array('NNRobots_Optin_Fire_Admin_Functions', 'entries_load'));
add_action( 'wp_ajax_nnr_of_entry_load', 					array('NNRobots_Optin_Fire_Admin_Functions', 'entry_load'));

// Get all tags and custom posts

add_action( 'wp_ajax_nnr_of_get_categories', 				array('NNRobots_Optin_Fire_Admin_Functions', 'get_categories'));
add_action( 'wp_ajax_nnr_of_get_tags', 						array('NNRobots_Optin_Fire_Admin_Functions', 'get_tags'));
add_action( 'wp_ajax_nnr_of_get_posts', 					array('NNRobots_Optin_Fire_Admin_Functions', 'get_posts'));

// Get Newsletter lists

add_action( 'wp_ajax_nnr_of_get_mailchimp_lists', 			array('NNRobots_Optin_Fire_Admin_Functions', 'get_mailchimp_lists'));
add_action( 'wp_ajax_nnr_of_get_aweber_lists', 				array('NNRobots_Optin_Fire_Admin_Functions', 'get_aweber_lists'));
add_action( 'wp_ajax_nnr_of_get_getresponse_lists', 		array('NNRobots_Optin_Fire_Admin_Functions', 'get_getresponse_lists'));
add_action( 'wp_ajax_nnr_of_get_campaignmonitor_lists', 	array('NNRobots_Optin_Fire_Admin_Functions', 'get_campaignmonitor_lists'));
add_action( 'wp_ajax_nnr_of_update_campaignmonitor_lists', 	array('NNRobots_Optin_Fire_Admin_Functions', 'update_campaignmonitor_lists'));
add_action( 'wp_ajax_nnr_of_get_madmimi_lists', 			array('NNRobots_Optin_Fire_Admin_Functions', 'get_madmimi_lists'));
add_action( 'wp_ajax_nnr_of_get_infusionsoft_lists', 		array('NNRobots_Optin_Fire_Admin_Functions', 'get_infusionsoft_lists'));
add_action( 'wp_ajax_nnr_of_get_mymail_lists', 				array('NNRobots_Optin_Fire_Admin_Functions', 'get_mymail_lists'));
add_action( 'wp_ajax_nnr_of_get_activecampaign_lists', 		array('NNRobots_Optin_Fire_Admin_Functions', 'get_activecampaign_lists'));

// Miscellaneous

add_action( 'wp_ajax_nnr_of_get_all_count', 				array('NNRobots_Optin_Fire_Admin_Functions', 'get_all_count'));
add_action( 'wp_ajax_nnr_of_get_active_count', 				array('NNRobots_Optin_Fire_Admin_Functions', 'get_active_count'));
add_action( 'wp_ajax_nnr_of_get_inactive_count', 			array('NNRobots_Optin_Fire_Admin_Functions', 'get_inactive_count'));

add_action( 'wp_ajax_nnr_of_add_new', 						array('NNRobots_Optin_Fire_Admin_Functions', 'add_new'));
add_action( 'wp_ajax_nnr_of_remove', 						array('NNRobots_Optin_Fire_Admin_Functions', 'remove'));
add_action( 'wp_ajax_nnr_of_duplicate', 					array('NNRobots_Optin_Fire_Admin_Functions', 'duplicate'));
add_action( 'wp_ajax_nnr_of_change_status', 				array('NNRobots_Optin_Fire_Admin_Functions', 'change_status'));

add_action( 'wp_ajax_nnr_of_change_test_status', 			array('NNRobots_Optin_Fire_Admin_Functions', 'change_test_status'));
add_action( 'wp_ajax_nnr_of_add_variant', 					array('NNRobots_Optin_Fire_Admin_Functions', 'add_variant'));
add_action( 'wp_ajax_nnr_of_get_end_test_options', 			array('NNRobots_Optin_Fire_Admin_Functions', 'get_end_test_options'));
add_action( 'wp_ajax_nnr_of_end_test', 						array('NNRobots_Optin_Fire_Admin_Functions', 'end_test'));

add_action( 'wp_ajax_nnr_of_send_weekly_email', 			array('NNRobots_Optin_Fire_Admin_Functions', 'send_weekly_email'));
add_action( 'wp_ajax_nnr_of_save_default_newsletter', 		array('NNRobots_Optin_Fire_Admin_Functions', 'default_newsletter'));
add_action( 'wp_ajax_nnr_of_live_preview', 					array('NNRobots_Optin_Fire_Admin_Functions', 'live_preview'));

// Cron jobs

add_action( 'initialize_optin_fire_stats_daily_cron', 		array('NNRobots_Optin_Fire_Admin_Functions', 'initialize_optin_fire_stats_daily'), 10 ,2 );
add_action( 'setup_optin_fire_email_stats_cron', 			array('NNRobots_Optin_Fire_Admin_Functions', 'setup_optin_fire_email_stats'), 10 ,2 );

// Shortcode Media Buttons

add_action( 'media_buttons', 								array('NNRobots_Optin_Fire_Admin_Functions', 'add_media_buttons'), 20);
add_action( 'wp_enqueue_media', 							array('NNRobots_Optin_Fire_Admin_Functions', 'include_shortcode_button_scripts'));

/**
 *
 * Main class for all admin functions
 *
 * @since 1.1.2
 */
class NNRobots_Optin_Fire_Admin_Functions {

	/**
	 * pie_chart_colors
	 *
	 * @var mixed
	 * @access public
	 * @static
	 */
	static $pie_chart_colors = array(
		'#00a0b0',
		'#edc951',
		'#eb6841',
		'#4f372d',
		'#cc2a36',
	);

	/**
	 * Add a media button for adding Optin Fire shortcode
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function add_media_buttons(){

		// Include DB file for accessing optins

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/model/db.php');
		$optins = NNRobots_Optin_Fire_DB::get_by_type(array(1,2,3,4,5));

		echo '<button class="button ' . NNRobots_Optin_Fire::$prefix_dash . 'shortcode-builder"><span></span>Optin Fire</button>
		<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'shortcode-builder-container">
		<div class="postbox ' . NNRobots_Optin_Fire::$prefix_dash . 'shortcode-builder-box" style="display:none;">
			<h3>
				<span>' . __('Optin Fire Shortcode Builder', NNRobots_Optin_Fire::$text_domain) . '</span>

				<button style="float: right;margin-right: 0px;" class="button ' . NNRobots_Optin_Fire::$prefix_dash . 'shortcode-builder-close">Close</button>
				<button style="float: right;margin-right: 12px;" class="button button-primary ' . NNRobots_Optin_Fire::$prefix_dash . 'shortcode-builder-add">Insert Shortcode</button>
			</h3>
			<div class="inside">
				<p style="display:none;">
					<strong><label for="' . NNRobots_Optin_Fire::$prefix_dash . 'shortcode">' . __( 'ShortCode:', NNRobots_Optin_Fire::$text_domain). '</label></strong>
					<code class="' . NNRobots_Optin_Fire::$prefix_dash . 'shortcode"></code>
				</p>

				<!-- Content -->

				<p>
					<strong><label for="' . NNRobots_Optin_Fire::$prefix_dash . 'content">' . __( 'Optin:', NNRobots_Optin_Fire::$text_domain) . '</label></strong>
					<select id="' . NNRobots_Optin_Fire::$prefix_dash . 'id" name="' . NNRobots_Optin_Fire::$prefix_dash . 'id" class="' . NNRobots_Optin_Fire::$prefix_dash . 'shortcode-input" data-shortcode="id">';

					foreach ( $optins as $optin ) {
						echo '<option value="' . $optin['id'] . '">' . __( $optin['name'], NNRobots_Optin_Fire::$text_domain). '</option>';
					}

					echo '</select><br/>
					<em>' . __('Select the Optin you want to display.', NNRobots_Optin_Fire::$text_domain). '</em>
				</p>

			</div>
		</div>
		</div>';

	}

	/**
	 * Include the shortcode builder stylesheet and script
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function include_shortcode_button_scripts() {

		if ( isset($_GET['post']) ) {

			// Styles

			wp_enqueue_style(NNRobots_Optin_Fire::$prefix . 'shortcode_builder_css', NNROBOTS_OPTIN_FIRE_PLUGIN_URL . '/admin/css/shortcode-builder.css');

			// Scripts

			wp_enqueue_script(NNRobots_Optin_Fire::$prefix . 'shortcode_builder_js', NNROBOTS_OPTIN_FIRE_PLUGIN_URL . '/admin/js/shortcode-builder.js', array('jquery'));
			wp_localize_script(NNRobots_Optin_Fire::$prefix . 'shortcode_builder_js', 'nnr_of_shortcode', array(
				'prefix' 	=> NNRobots_Optin_Fire::$prefix_dash,
			));
		}

	}

	/**
	 * Return a default optin_fire
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function default_optin_fire() {
		return array(
			'id' 			=> '',
			'type'			=> '1',
			'name' 			=> '',
			'title' 		=> __('Optin Fire', NNRobots_Optin_Fire::$text_domain),
			'text' 			=> __('Create Optins that display the right message at the right time', NNRobots_Optin_Fire::$text_domain),
			'image' 		=> '',
			'active' 		=> 'Active',
			'news_letter' 	=> array(
				'type' 						=> 'wordpress',
				'first_name_placeholder'	=> __('First Name', NNRobots_Optin_Fire::$text_domain),
				'last_name_placeholder'		=> __('Last Name', NNRobots_Optin_Fire::$text_domain),
				'email_placeholder'			=> __('Email', NNRobots_Optin_Fire::$text_domain),
				'first_name'				=> true,
				'last_name'					=> true,
				'success_action'			=> 'message',
				'success_url'				=> '',
				'success_message'			=> __('We will be in touch soon!', NNRobots_Optin_Fire::$text_domain),
				'button_text'				=> __('Subscribe', NNRobots_Optin_Fire::$text_domain),
				'mailchimp' => array(
					'api_key'	=> '',
					'list'		=> '',
					'optin'		=> true,
				),
				'aweber' => array(
					'consumer_key' 		=> '',
					'consumer_secret' 	=> '',
					'access_key' 		=> '',
					'access_secret' 	=> '',
					'account_id' 		=> '',
					'list_id' 			=> ''
				),
				'getresponse'	=> array(
					'api_key' 		=> '',
					'campaign'		=> '',
				),
				'campaignmonitor'	=> array(
					'api_key'			=> '',
					'client' 			=> '',
					'list'				=> '',
				),
				'madmimi'	=> array(
					'api_key'			=> '',
					'username' 			=> '',
					'list'				=> '',
				),
				'infusionsoft'	=> array(
					'app_id'			=> '',
					'api_key' 			=> '',
					'list'				=> '',
				),
				'mymail' 	=> array(
					'list'		=> '',
				),
				'activecampaign' 	=> array(
					'api_url'	=> '',
					'api_key'	=> '',
					'list'		=> '',
				),
				'feedburner' 	=> array(
					'id'		=> '',
				),
			),
			'template' 		=> array(
				'type'		=> '3',
				'args'		=> array(
					'call_to_action'		=> 'newsletter',
					'footer'				=> __('We promise never to spam or share your information.', NNRobots_Optin_Fire::$text_domain),
					'footer_icon'			=> 'fa-lock',
					'custom_html'			=> '',
					'contact_icon'			=> 'fa-envelope',
					'contact_icon_place'	=> 'before',
					'subscribe_icon'		=> 'fa-envelope',
					'subscribe_icon_place'	=> 'before',
					'link_type' 			=> 'button',
					'link_target' 			=> '_blank',
					'link_rel' 				=> true,
					'link_url' 				=> 'https://99robots.com',
					'link_name' 			=> 'Click Here!',
					'link_text_color'		=> '#ffffff',
					'link_button_color'		=> '#4FC000',
					'yes_text' 				=> __('YES', NNRobots_Optin_Fire::$text_domain),
					'yes_sub_text' 			=> __("let's do this.", NNRobots_Optin_Fire::$text_domain),
					'yes_link_target' 		=> '_blank',
					'yes_link_rel' 			=> true,
					'yes_link_url' 			=> 'https://99robots.com',
					'no_text' 				=> __('NO', NNRobots_Optin_Fire::$text_domain),
					'no_sub_text' 			=> __("let's consider it gone.", NNRobots_Optin_Fire::$text_domain),
					'no_link_target' 		=> '_blank',
					'no_link_rel' 			=> true,
					'no_link_url' 			=> 'https://99robots.com',
					'push_pull'				=> 'no',
					'full'					=> 'no',
					'shadow'				=> 'no',
					'banner_location' 		=> 'Top',
					'banner_display'		=> 'Bar',
					'icon'					=> 'fa-fire',
					'slide_direction'		=> 'up',
					'effect'				=> 'slide',
					'size'					=> 'medium',
					'stub_location'			=> 'right',
					'stub_shape'			=> 'drop',
					'location' 				=> '9',
					'position'				=> 'fixed',
					'move_body'				=> 'yes',
					'animation'				=> 'yes',
					'popup_animation'		=> 'slideDown',
					'video_url'				=> '',
					'list'					=>  array(
						'color'			=> '#000000',
						'items'			=> array(
							array('icon' => 'fa-envelope', 		'text' => __('Increase signups', NNRobots_Optin_Fire::$text_domain)),
							array('icon' => 'fa-line-chart', 	'text' => __('Drive more traffic', NNRobots_Optin_Fire::$text_domain)),
							array('icon' => 'fa-crosshairs', 	'text' => __('Create targeted call to action', NNRobots_Optin_Fire::$text_domain)),
							array('icon' => 'fa-comment-o', 	'text' => __('Display the right message at the right time', NNRobots_Optin_Fire::$text_domain)),
							array('icon' => 'fa-group', 		'text' => __('Show your content to the correct audience', NNRobots_Optin_Fire::$text_domain)),
						),
					),
					'social' => array(
						'color'			=> '#000000',
						'icons'			=> array(
							array('type' => 'fa-facebook', 		'url' => 'https://www.facebook.com/99robots'),
							array('type' => 'fa-google-plus', 	'url' => 'https://plus.google.com/99robots/posts'),
							array('type' => 'fa-twitter', 		'url' => 'https://twitter.com/99robots'),
							array('type' => 'fa-linkedin', 		'url' => 'http://linkedin.com/company/99robots'),
							array('type' => 'fa-youtube', 		'url' => 'http://youtube.com/99robots/'),
							array('type' => 'fa-reddit', 		'url' => 'http://reddit.com/u/99robots'),
							array('type' => 'fa-instagram', 	'url' => 'http://instagram.com/99robots'),
							array('type' => 'fa-pinterest', 	'url' => 'http://pinterest.com/99robots/'),
						),
					),
					'contact_us'  => array(
						'email_placeholder'			=> __('Email', NNRobots_Optin_Fire::$text_domain),
						'subject_placeholder'		=> __('Subject', NNRobots_Optin_Fire::$text_domain),
						'message_placeholder'		=> __('Message', NNRobots_Optin_Fire::$text_domain),
						'button_text'				=> __('Contact Us', NNRobots_Optin_Fire::$text_domain),
						'email'						=> get_bloginfo('admin_email'),
						'thank_you'					=> __('Thank you. Your message has been received by our team, and we will reply shortly.', NNRobots_Optin_Fire::$text_domain),
					),
				),
			),
			'trigger' 		=> array(
				'manual_display'	=> 'no',
				'display_on'		=> 'post',
				'post'				=> array('all' => true),
				'args'				=> array(
					'type'				=> 'timer',
					'timer' 			=> '0',
					'scroll' 			=> '75',
					'users'				=> 'any',
					'user_roles'		=> array(),
					'referrer_type'		=> 'any',
					'referrer'			=> 't.co,www.facebook.com,plus.url.google.com,www.linkedin.com',
				),
			),
			'style'			=> array(
				'background_type'		=> 'pattern',
				'background_image'		=> '',
				'background_color' 		=> '#ffffff',
				'background_pattern'	=> 'none',
				'background_size'		=> 'auto',
				'background_repeat'		=> 'no-repeat',
				'background_position'	=> 'center center',
				'text_align'			=> 'center',
				'color' 				=> '#333333',
				'heading_color' 		=> '#333333',
				'border_size'			=> '1',
				'icon_color'			=> '#000000',
				'close_button_color'	=> '#000000',
				'border_color' 			=> '#4FC000',
				'button_shape'			=> 'rounded',
				'nl_color' 				=> '#ffffff',
				'nl_bg_color' 			=> '#4FC000',
				'cu_color' 				=> '#ffffff',
				'cu_bg_color' 			=> '#4FC000',
				'yes_color' 			=> '#ffffff',
				'yes_bg_color' 			=> '#4FC000',
				'no_color' 				=> '#ffffff',
				'no_bg_color' 			=> '#d9534f',
				'font_size'				=> 'auto',
				'font_weight'			=> 'normal',
				'google_fonts'			=> false,
				'heading_google_fonts'	=> false,
				'font_family_heading'	=> 'Arial, Helvetica, sans-serif',
				'font_family'			=> 'Arial, Helvetica, sans-serif',
				'custom_css'			=> '',
			),
			'args'			=> array(
				'start_date'			=> null,
				'end_date'				=> null,
				'display_screen'		=> 'both',
				'show_after_success'	=> 'no',
				'close_button'   		=> false,
				'dont_show_again'		=> false,
				'powered_by'			=> true,
				'ab_testing'			=> array(
					'active'			=> false,
					'parent'			=> '',
					'children'			=> array(),
					'start_date'		=> '',
				),
				'placement'				=> array(
					'type'				=> 'after',
					'paragraphs'		=> '1',
					'headlines'			=> '1',
				)
			)
		);
	}

	/**
	 * Default settings for all optin fires
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function default_global_settings() {
		return array(
			'send_weekly_email'	=> true,
		);
	}

	/**
	 * Get all the data into an array format to save to the DB
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function save_data() {

		// Get all WordPress roles

		global $wp_roles;

		// Get all WordPress post types

		$post_types = get_post_types(array('public' => true));

		// Include files for database management

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/model/db.php');
		$nnrobots_optin_fire_db = new NNRobots_Optin_Fire_DB();

		// Get default optin data

		$default_optin_fire = self::default_optin_fire();

		// Get the current optin data

		$val = $nnrobots_optin_fire_db->get_data_from_id($_GET["optin_fire_id"]);

		$val['type']                                      = $_POST[NNRobots_Optin_Fire::$prefix_dash . 'type'];

		$val['name']                                      = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'name']) ?
															stripcslashes(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'name'])) : 'My Optin';

		$val['title']                                     = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'title']) ?
															htmlentities(stripcslashes($_POST[NNRobots_Optin_Fire::$prefix_dash . 'title'])) :
															$default_optin_fire['title'];

		$val['text']                                      = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'text']) ?
															htmlentities(stripcslashes($_POST[NNRobots_Optin_Fire::$prefix_dash . 'text'])) :
															$default_optin_fire['text'];

		$val['image']                                     = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'image']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'image']) :
															$default_optin_fire['image'];

		$val['active']                                    = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'active']) ?
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'active'] :
															$default_optin_fire['active'];

		// Template Args


		$val['template']['type']                          = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-type']) ?
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-type'] :
															$default_optin_fire['template']['type'];

		$val['template']['args']['call_to_action']        = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-call-to-action']) ?
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-call-to-action'] :
															$default_optin_fire['template']['args']['call_to_action'];

		$val['template']['args']['footer']                = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-footer']) ?
															htmlentities(stripcslashes($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-footer'])) :
															$default_optin_fire['template']['args']['footer'];

		$val['template']['args']['footer_icon']           = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-footer-icon']) ?
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-footer-icon'] :
															$default_optin_fire['template']['args']['footer_icon'];

        $val['template']['args']['custom_html']           = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'custom-html']) ?
															htmlentities(stripcslashes($_POST[NNRobots_Optin_Fire::$prefix_dash . 'custom-html'])) :
															$default_optin_fire['template']['args']['custom_html'];

		$val['template']['args']['contact_icon']          = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-contact-icon']) ?
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-contact-icon'] :
															$default_optin_fire['template']['args']['contact_icon'];

		$val['template']['args']['contact_icon_place']    = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-contact-icon-place']) ?
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-contact-icon-place'] :
															$default_optin_fire['template']['args']['contact_icon_place'];

		$val['template']['args']['subscribe_icon']        = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-subscribe-icon']) ?
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-subscribe-icon'] :
															$default_optin_fire['template']['args']['subscribe_icon'];

		$val['template']['args']['subscribe_icon_place']  = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-subscribe-icon-place']) ?
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-subscribe-icon-place'] :
															$default_optin_fire['template']['args']['subscribe_icon_place'];

		$val['template']['args']['clickable_image']       = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-clickable-image']) ?
															htmlentities(stripcslashes($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-clickable-image'])) :
															$default_optin_fire['template']['args']['clickable_image'];

		$val['template']['args']['link_type']             = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-link-type']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-link-type']) :
															$default_optin_fire['template']['args']['link_type'];

		$val['template']['args']['link_target']           = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-link-target']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-link-target']) :
															$default_optin_fire['template']['args']['link_target'];

		$val['template']['args']['link_rel']              = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-link-rel']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-link-rel']) :
															$default_optin_fire['template']['args']['link_rel'];

		$val['template']['args']['link_url']              = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-link-url']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-link-url']) :
															$default_optin_fire['template']['args']['link_url'];

		$val['template']['args']['link_name']             = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-link-name']) ?
															stripcslashes(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-link-name'])) :
															$default_optin_fire['template']['args']['link_name'];

		$val['template']['args']['link_text_color']       = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-link-text-color']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-link-text-color']) :
															$default_optin_fire['template']['args']['link_text_color'];

		$val['template']['args']['link_button_color']     = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-link-button-color']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-link-button-color']) :
															$default_optin_fire['template']['args']['link_button_color'];

		$val['template']['args']['yes_text']              = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-yes-text']) ?
															stripcslashes(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-yes-text'])) :
															$default_optin_fire['template']['args']['yes_text'];

		$val['template']['args']['yes_sub_text']          = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-yes-sub-text']) ?
															stripcslashes(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-yes-sub-text'])) :
															$default_optin_fire['template']['args']['yes_sub_text'];

		$val['template']['args']['yes_link_target']       = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-yes-link-target']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-yes-link-target']) :
															$default_optin_fire['template']['args']['yes_link_target'];

		$val['template']['args']['yes_link_rel']          = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-yes-link-rel']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-yes-link-rel']) :
															$default_optin_fire['template']['args']['yes_link_rel'];

		$val['template']['args']['yes_link_url']          = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-yes-link-url']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-yes-link-url']) :
															$default_optin_fire['template']['args']['yes_link_url'];

		$val['template']['args']['no_text']               = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-no-text']) ?
															stripcslashes(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-no-text'])) :
															$default_optin_fire['template']['args']['no_text'];

		$val['template']['args']['no_sub_text']           = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-no-sub-text']) ?
															stripcslashes(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-no-sub-text'])) :
															$default_optin_fire['template']['args']['no_sub_text'];

		$val['template']['args']['no_link_target']        = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-no-link-target']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-no-link-target']) :
															$default_optin_fire['template']['args']['no_link_target'];

		$val['template']['args']['no_link_rel']           = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-no-link-rel']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-no-link-rel']) :
															$default_optin_fire['template']['args']['no_link_rel'];

		$val['template']['args']['no_link_url']           = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-no-link-url']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'template-args-no-link-url']) :
															$default_optin_fire['template']['args']['no_link_url'];

		$val['template']['args']['size']                  = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'size']) ?
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'size'] :
															$default_optin_fire['template']['args']['size'];

		$val['template']['args']['stub_location']         = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'stub-location']) ?
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'stub-location'] :
															$default_optin_fire['template']['args']['stub_location'];

		$val['template']['args']['stub_shape']            = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'stub-shape']) ?
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'stub-shape'] :
															$default_optin_fire['template']['args']['stub_shape'];

		$val['template']['args']['slide_direction']       = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'slide-direction']) ?
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'slide-direction'] :
															$default_optin_fire['template']['args']['slide_direction'];

		$val['template']['args']['effect']                = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'effect']) ?
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'effect'] :
															$default_optin_fire['template']['args']['effect'];

		$val['template']['args']['banner_location']       = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'banner-location']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'banner-location']) :
															$default_optin_fire['template']['args']['banner_location'];

		$val['template']['args']['banner_display']       = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'banner-display']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'banner-display']) :
															$default_optin_fire['template']['args']['banner_display'];

		$val['template']['args']['icon']                  = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'icon']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'icon']) :
															$default_optin_fire['template']['args']['icon'];

		$val['template']['args']['push_pull']             = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'push-pull']) &&
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'push-pull'] ? 'yes' : 'no';

		$val['template']['args']['full']                  = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'full']) ?
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'full'] :
															$default_optin_fire['template']['args']['full'];

		$val['template']['args']['location']              = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'location']) ?
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'location'] :
															$default_optin_fire['template']['args']['location'];

		$val['template']['args']['animation']             = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'animation']) &&
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'animation'] ? 'yes' : 'no';

		$val['template']['args']['popup_animation']       = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'popup-animation']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'popup-animation']) :
															$default_optin_fire['template']['args']['popup_animation'];

		$val['template']['args']['position']              = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'position']) ?
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'position'] :
															$default_optin_fire['template']['args']['position'];

		$val['template']['args']['move_body']             = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'move-body']) &&
															$_POST[NNRobots_Optin_Fire::$prefix_dash . 'move-body'] ? 'yes' : 'no';

		$val['template']['args']['video_url']       	  = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'video-url']) ?
															sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'video-url']) :
															$default_optin_fire['template']['args']['video_url'];

		// Contact Us

		$val['template']['args']['contact_us']['email_placeholder']   = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'contact-us-email-placeholder']) ?
																		stripcslashes(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'contact-us-email-placeholder'])) :
																		$default_optin_fire['template']['args']['contact_us']['email_placeholder'];

		$val['template']['args']['contact_us']['subject_placeholder'] = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'contact-us-subject-placeholder']) ?
																		stripcslashes(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'contact-us-subject-placeholder'])) :
																		$default_optin_fire['template']['args']['contact_us']['subject_placeholder'];

		$val['template']['args']['contact_us']['message_placeholder'] = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'contact-us-message-placeholder']) ?
																		stripcslashes(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'contact-us-message-placeholder'])) :
																		$default_optin_fire['template']['args']['contact_us']['message_placeholder'];

		$val['template']['args']['contact_us']['button_text']         = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'contact-us-button-text']) ?
																		stripcslashes(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'contact-us-button-text'])) :
																		$default_optin_fire['template']['args']['contact_us']['button_text'];

		$val['template']['args']['contact_us']['email']               = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'contact-us-email']) ?
																		sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'contact-us-email']) :
																		$default_optin_fire['template']['args']['contact_us']['email'];

		$val['template']['args']['contact_us']['thank_you']           = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'contact-us-thank-you']) ?
															  			stripcslashes($_POST[NNRobots_Optin_Fire::$prefix_dash . 'contact-us-thank-you']) :
															  			$default_optin_fire['template']['args']['contact_us']['thank_you'];


		// Args

		$val['args']['display_screen']            = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'display-screen']) ?
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'display-screen'] :
													$default_optin_fire['args']['display_screen'];

		$val['args']['start_date']                = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'start-date']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'start-date']) :
													date("m/d/Y");

		$val['args']['end_date']                  = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'end-date']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'end-date']) :
													date("m/d/Y", mktime(0, 0, 0, date("m"), date("d"), date("Y")+20));

		$val['args']['dont_show_again']           = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'dont-show-again']) &&
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'dont-show-again'] ? true : false;

		$val['args']['show_after_success']        = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'show-after-success']) &&
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'show-after-success'] ? 'yes' : 'no';

		$val['args']['close_button']              = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'close-button']) &&
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'close-button'] ? true : false;

		$val['args']['powered_by']                = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'powered-by']) &&
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'powered-by'] ? true : false;

		$val['args']['placement']['type']         = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'args-placement-type']) ?
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'args-placement-type'] :
													$default_optin_fire['args']['placement']['type'];

		$val['args']['placement']['paragraphs']   = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'args-placement-paragraphs']) ?
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'args-placement-paragraphs'] :
													$default_optin_fire['args']['placement']['paragraphs'];

		$val['args']['ab_testing']['name']        = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'abtest-name']) ?
													stripcslashes(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'abtest-name'])) :
													$val['args']['ab_testing']['name'];

		// Style

		$val['style']['background_type']          = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'background-type']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'background-type']) :
													$default_optin_fire['style']['background_type'];

		$val['style']['background_image']         = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'background-image']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'background-image']) :
													$default_optin_fire['style']['background_image'];

		$val['style']['background_color']         = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'background-color']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'background-color']) :
													$default_optin_fire['style']['background_color'];

		$val['style']['background_pattern']       = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'background-pattern']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'background-pattern']) :
													$default_optin_fire['style']['background_pattern'];

		$val['style']['background_size']          = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'background-size']) ?
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'background-size'] :
													$default_optin_fire['style']['background_size'];

		$val['style']['background_repeat']        = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'background-repeat']) ?
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'background-repeat'] :
													$default_optin_fire['style']['background_repeat'];

		$val['style']['background_position']      = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'background-position']) ?
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'background-position'] :
													$default_optin_fire['style']['background_position'];

		$val['style']['text_align']               = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'text-align']) ?
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'text-align'] :
													$default_optin_fire['style']['text_align'];

		$val['style']['border_color']             = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'border-color']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'border-color']) :
													$default_optin_fire['style']['border_color'];

		$val['style']['border_size']              = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'border-size']) ?
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'border-size'] :
													$default_optin_fire['style']['border_size'];

		$val['style']['icon_color']            	  = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'icon-color']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'icon-color']) :
													$default_optin_fire['style']['icon_color'];

		$val['style']['close_button_color']       = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'close-button-color']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'close-button-color']) :
													$default_optin_fire['style']['close_button_color'];

		$val['style']['color']                    = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'color']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'color']) :
													$default_optin_fire['style']['color'];

		$val['style']['heading_color']            = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'heading-color']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'heading-color']) :
													$default_optin_fire['style']['heading_color'];

		$val['style']['button_shape']             = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'button-shape']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'button-shape']) :
													$default_optin_fire['style']['button_shape'];

		$val['style']['cu_color']                 = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'cu-color']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'cu-color']) :
													$default_optin_fire['style']['nl_color'];

		$val['style']['cu_bg_color']              = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'cu-bg-color']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'cu-bg-color']) :
													$default_optin_fire['style']['cu_bg_color'];

		$val['style']['nl_color']                 = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'nl-color']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'nl-color']) :
													$default_optin_fire['style']['nl_color'];

		$val['style']['nl_bg_color']              = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'nl-bg-color']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'nl-bg-color']) :
													$default_optin_fire['style']['nl_bg_color'];

		$val['style']['yes_color']                = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'yes-color']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'yes-color']) :
													$default_optin_fire['style']['yes_color'];

		$val['style']['yes_bg_color']             = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'yes-bg-color']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'yes-bg-color']) :
													$default_optin_fire['style']['yes_bg_color'];

		$val['style']['no_color']                 = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'no-color']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'no-color']) :
													$default_optin_fire['style']['no_color'];

		$val['style']['no_bg_color']              = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'no-bg-color']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'no-bg-color']) :
													$default_optin_fire['style']['no_bg_color'];

		$val['style']['font_size']                = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'font-size']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'font-size']) :
													$default_optin_fire['style']['font_size'];

		$val['style']['font_weight']              = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'font-weight']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'font-weight']) :
													$default_optin_fire['style']['font_weight'];

		$val['style']['google_fonts']             = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'google-fonts']) &&
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'google-fonts'] ? true : false;

		$val['style']['heading_google_fonts']      = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'heading-google-fonts']) &&
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'heading-google-fonts'] ? true : false;

		$val['style']['font_family_heading']      = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'font-family-heading']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'font-family-heading']) :
													$default_optin_fire['style']['font_family_heading'];

		$val['style']['font_family']              = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'font-family']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'font-family']) :
													$default_optin_fire['style']['font_family'];

		$val['style']['custom_css']               = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'custom-css']) ?
													stripcslashes($_POST[NNRobots_Optin_Fire::$prefix_dash . 'custom-css']) :
													$default_optin_fire['style']['custom_css'];


		// Trigger

		$val['trigger']['manual_display']         = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-manual-display']) &&
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-manual-display'] ? 'yes' : 'no';

		$val['trigger']['display_on']          	  = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-display-on']) ?
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-display-on'] :
													$default_optin_fire['trigger']['display_on'];

		$val['trigger']['args']['type']           = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-args-type']) ?
													$_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-args-type'] :
													$default_optin_fire['trigger']['args']['type'];

		$val['trigger']['args']['timer']          = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-args-timer']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-args-timer']) :
													$default_optin_fire['trigger']['args']['timer'];

		$val['trigger']['args']['scroll']         = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-args-scroll']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-args-scroll']) :
													$default_optin_fire['trigger']['args']['scroll'];

		$val['trigger']['args']['users']          = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-args-users']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-args-users']) :
													$default_optin_fire['trigger']['args']['users'];

		// User roles

		foreach ($wp_roles->role_names as $role_name => $role) {
			$val['trigger']['args']['user_roles'][$role_name] = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'args-role-' . $role_name]) && $_POST[NNRobots_Optin_Fire::$prefix_dash . 'args-role-' . $role_name] ? true : false;
		}

		$val['trigger']['args']['referrer_type']  = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-args-referrer-type']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-args-referrer-type']) :
													$default_optin_fire['trigger']['args']['referrer_type'];

		$val['trigger']['args']['referrer']       = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-args-referrer']) ?
													sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-args-referrer']) :
													$default_optin_fire['trigger']['args']['referrer'];

		$val['trigger']['category']['id']         = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-category-id']) ?
													str_replace(' ', '', rtrim(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-category-id']), ',')) :
													$default_optin_fire['trigger']['args']['id'];

		$val['trigger']['tag']['id']              = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-tag-id']) ?
													str_replace(' ', '', rtrim(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-tag-id']), ',')) :
													$default_optin_fire['trigger']['tag']['id'];

		// Post Types

		foreach ($post_types as $post_type) {
			$val['trigger'][$post_type]['all']		= isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-all-' . $post_type]) &&
													  $_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-all-' . $post_type] ? true : false;

			$val['trigger'][$post_type]['id'] 		= isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-id-' . $post_type]) ?
												      str_replace(' ', '', rtrim(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-id-' . $post_type]), ',')) : '';
			$val['trigger'][$post_type]['exclude']  = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-exclude-' . $post_type]) ?
												      str_replace(' ', '', rtrim(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'trigger-exclude-' . $post_type]), ',')) : '';
		}

		// Social Icons

		$val['template']['args']['social']['color'] = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'social-color']) ?
													  sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'social-color']) :
													  $default_optin_fire['template']['args']['social']['color'];

		$social_url = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'social-url']) ? $_POST[NNRobots_Optin_Fire::$prefix_dash . 'social-url'] : '';
		$social_type = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'social-type']) ? $_POST[NNRobots_Optin_Fire::$prefix_dash . 'social-type'] : '';

		$social_items = array();

		for ($i = 0; $i < count($social_url); $i++) {

			if (isset($social_url[$i]) && $social_url[$i] != '' && $social_type[$i] != '') {
				$social_items[] = array(
					'url' 	=> stripcslashes(sanitize_text_field($social_url[$i])),
					'type' 	=> sanitize_text_field($social_type[$i])
				);
			}
		}

		$val['template']['args']['social']['icons'] = $social_items;

		// List Items

		$val['template']['args']['list']['color'] 	= isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'list-color']) ?
													  sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'list-color']) :
													  $default_optin_fire['template']['args']['list']['color'];

		$list_text = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'list-text']) ? $_POST[NNRobots_Optin_Fire::$prefix_dash . 'list-text'] : '';
		$list_icon = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'list-icon']) ? $_POST[NNRobots_Optin_Fire::$prefix_dash . 'list-icon'] : '';

		$list_items = array();

		for ($i = 0; $i < count($list_text); $i++) {

			if (isset($list_text[$i]) && $list_text[$i] != '' && $list_icon[$i] != '') {
				$list_items[] = array(
					'icon' 	=> sanitize_text_field($list_icon[$i]),
					'text' 	=> stripcslashes(sanitize_text_field($list_text[$i]))
				);
			}
		}

		$val['template']['args']['list']['items'] = $list_items;

		// News Letter

		$val['news_letter']['type']                               = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-type']) ?
																	$_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-type'] :
																	$default_optin_fire['news_letter']['type'];

		$val['news_letter']['first_name_placeholder']             = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-first-name-placeholder']) ?
																	stripcslashes(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-first-name-placeholder'])) :
																	$default_optin_fire['news_letter']['first_name_placeholder'];

		$val['news_letter']['last_name_placeholder']              = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-last-name-placeholder']) ?
																	stripcslashes(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-last-name-placeholder'])) :
																	$default_optin_fire['news_letter']['last_name_placeholder'];

		$val['news_letter']['email_placeholder']                  = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-email-placeholder']) ?
																	stripcslashes(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-email-placeholder'])) :
																	$default_optin_fire['news_letter']['email_placeholder'];

		$val['news_letter']['first_name']                         = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-first-name']) &&
																	$_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-first-name'] ? true : false;

		$val['news_letter']['last_name']                          = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-last-name']) &&
																	$_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-last-name'] ? true : false;

		$val['news_letter']['success_action']            		  = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-success-action']) ?
																	$_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-success-action'] :
																	$default_optin_fire['news_letter']['success_action'];

		$val['news_letter']['success_url']            		      = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-success-url']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-success-url']) :
																	$default_optin_fire['news_letter']['success_url'];

		$val['news_letter']['success_message']            		  = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-success-message']) ?
																	stripcslashes(sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-success-message'])) :
																	$default_optin_fire['news_letter']['success_message'];

		$val['news_letter']['button_text']            		      = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-button-text']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-button-text']) :
																	$default_optin_fire['news_letter']['button_text'];

		// MailChimp

		$val['news_letter']['mailchimp']['api_key']               = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-mailchimp-api-key']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-mailchimp-api-key']) :
																	$default_optin_fire['news_letter']['mailchimp']['api_key'];

		$val['news_letter']['mailchimp']['list']                  = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-mailchimp-list']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-mailchimp-list']) :
																	$default_optin_fire['news_letter']['mailchimp']['list'];

		$val['news_letter']['mailchimp']['optin']                 = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-mailchimp-optin']) &&
																	$_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-mailchimp-optin'] ? true : false;

		// Aweber

		$val['news_letter']['aweber']['consumer_key']             = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-aweber-consumer-key']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-aweber-consumer-key']) :
																	$default_optin_fire['news_letter']['aweber']['consumer_key'];

		$val['news_letter']['aweber']['consumer_secret']          = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-aweber-consumer-secret']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-aweber-consumer-secret']) :
																	$default_optin_fire['news_letter']['aweber']['consumer_secret'];

		$val['news_letter']['aweber']['access_key']               = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-aweber-access-key']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-aweber-access-key']) :
																	$default_optin_fire['news_letter']['aweber']['access_key'];

		$val['news_letter']['aweber']['access_secret']            = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-aweber-access-secret']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-aweber-access-secret']) :
																	$default_optin_fire['news_letter']['aweber']['access_secret'];

		$val['news_letter']['aweber']['account_id']               = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-aweber-account-id']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-aweber-account-id']) :
																	$default_optin_fire['news_letter']['aweber']['account_id'];

		$val['news_letter']['aweber']['list_id']                  = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-aweber-list-id']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-aweber-list-id']) :
																	$default_optin_fire['news_letter']['aweber']['list_id'];

		// Get Response

		$val['news_letter']['getresponse']['api_key']             = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-getresponse-api-key']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-getresponse-api-key']) :
																	$default_optin_fire['news_letter']['getresponse']['api_key'];

		$val['news_letter']['getresponse']['campaign']            = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-getresponse-campaign']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-getresponse-campaign']) :
																	$default_optin_fire['news_letter']['getresponse']['campaign'];

		// Campiagn Monitor

		$val['news_letter']['campaignmonitor']['api_key']         = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-campaignmonitor-api-key']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-campaignmonitor-api-key']) :
																	$default_optin_fire['news_letter']['campaignmonitor']['api_key'];

		$val['news_letter']['campaignmonitor']['client']          = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-campaignmonitor-client']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-campaignmonitor-client']) :
																	$default_optin_fire['news_letter']['campaignmonitor']['client'];

		$val['news_letter']['campaignmonitor']['list']            = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-campaignmonitor-list']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-campaignmonitor-list']) :
																	$default_optin_fire['news_letter']['campaignmonitor']['list'];

		// Mad Mimi

		$val['news_letter']['madmimi']['api_key']                 = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-madmimi-api-key']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-madmimi-api-key']) :
																	$default_optin_fire['news_letter']['madmimi']['api_key'];

		$val['news_letter']['madmimi']['username']                = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-madmimi-username']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-madmimi-username']) :
																	$default_optin_fire['news_letter']['madmimi']['username'];

		$val['news_letter']['madmimi']['list']                    = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-madmimi-list']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-madmimi-list']) :
																	$default_optin_fire['news_letter']['madmimi']['list'];

		// Infusion Soft

		$val['news_letter']['infusionsoft']['app_id']             = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-infusionsoft-app-id']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-infusionsoft-app-id']) :
																	$default_optin_fire['news_letter']['infusionsoft']['app_id'];

		$val['news_letter']['infusionsoft']['api_key']            = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-infusionsoft-api-key']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-infusionsoft-api-key']) :
																	$default_optin_fire['news_letter']['infusionsoft']['api_key'];

		$val['news_letter']['infusionsoft']['list']               = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-infusionsoft-list']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-infusionsoft-list']) :
																	$default_optin_fire['news_letter']['infusionsoft']['list'];

		// MyMail

		$val['news_letter']['mymail']['list']                     = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-mymail-list']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-mymail-list']) :
																	$default_optin_fire['mymail']['list'];

		// Active Campaign

		$val['news_letter']['activecampaign']['app_url']          = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-activecampaign-app-url']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-activecampaign-app-url']) :
																	$default_optin_fire['news_letter']['activecampaign']['app_url'];

		$val['news_letter']['activecampaign']['api_key']          = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-activecampaign-api-key']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-activecampaign-api-key']) :
																	$default_optin_fire['news_letter']['activecampaign']['api_key'];

		$val['news_letter']['activecampaign']['list']             = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-activecampaign-list']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-activecampaign-list']) :
																	$default_optin_fire['news_letter']['activecampaign']['list'];

		// feedburner

		$val['news_letter']['feedburner']['id']                   = isset($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-feedburner-id']) ?
																	sanitize_text_field($_POST[NNRobots_Optin_Fire::$prefix_dash . 'news-letter-feedburner-id']) :
																	$default_optin_fire['feedburner']['id'];

		return $val;
	}

	/**
	 * Load all stats using ajax to make back-end more responsive
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function stats_load() {

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . "core/model/stats.php");
		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . "admin/model/db.php");

		$db = new NNRobots_Optin_Fire_DB();
		$optin_fires = $db->get_optin_fires();

		// Get Start and End Dates

		$start_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
		$end_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, strtotime(current_time('mysql')));

		$post_start_date = urldecode($_POST['start_date']);
		$post_end_date = urldecode($_POST['end_date']);

		if (isset($post_start_date) && $post_start_date != '') {
			$start_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, strtotime($post_start_date));
		}

		if (isset($post_end_date) && $post_end_date != '') {
			$end_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, strtotime($post_end_date));
		}

		global $wpdb;

		// All optin_fire stats

		if (isset($_POST['optin_fire_id']) && $_POST['optin_fire_id'] == 'false') {

			$stats = NNRobots_Stats_OF::getStats($start_date, $end_date);
			$optin_fire_stats = array();

			foreach ($optin_fires as $optin_fire) {
				foreach ($stats as $stat) {

					if ( $optin_fire['id'] == $stat['optin_fire_id'] ) {

						// Active

						if ( $optin_fire['active'] == 'Active' &&
							( !isset($optin_fire['args']['ab_testing']['active']) || ( isset($optin_fire['args']['ab_testing']['active']) && !$optin_fire['args']['ab_testing']['active'] ) )) {
							$row_class = NNRobots_Optin_Fire::$prefix_dash . 'active-row';
						}

						// Test

						else if ( $optin_fire['active'] == 'Active' && isset($optin_fire['args']['ab_testing']['active']) && $optin_fire['args']['ab_testing']['active'] ) {
							$row_class = NNRobots_Optin_Fire::$prefix_dash . 'test-row';
						}

						// Inactive

						else {
							$row_class = NNRobots_Optin_Fire::$prefix_dash . 'inactive-row';
						}

						// If the optin is a variant add to parents stats

						if ( isset($optin_fire['args']['ab_testing']['is_variant']) && $optin_fire['args']['ab_testing']['is_variant'] ) {

							$optin_fire_stats[$optin_fire['args']['ab_testing']['parent']] = array_merge($optin_fire_stats[$optin_fire['args']['ab_testing']['parent']], array(
								'optin_fire_id'		=> $optin_fire['args']['ab_testing']['parent'],
								'optin_fire_type'	=> $optin_fire['type'],
								'row_class'			=> $row_class,
								'test'				=> isset($optin_fire['args']['ab_testing']['active']) && $optin_fire['args']['ab_testing']['active'] ? true : false,
								'date'				=> $stat['date'],
								'impressions'		=> isset($optin_fire_stats[$optin_fire['args']['ab_testing']['parent']]['impressions']) ?
													   $optin_fire_stats[$optin_fire['args']['ab_testing']['parent']]['impressions'] + $stat['impressions'] :
													   $stat['impressions'],
								'conversions'		=> isset($optin_fire_stats[$optin_fire['args']['ab_testing']['parent']]['conversions']) ?
													   $optin_fire_stats[$optin_fire['args']['ab_testing']['parent']]['conversions'] + $stat['conversions'] :
													   $stat['conversions'],
							));

						} else {
							$optin_fire_stats[$optin_fire['id']] = array(
								'optin_fire_id'		=> $stat['optin_fire_id'],
								'optin_fire_name'	=> $optin_fire['args']['ab_testing']['active'] ? $optin_fire['args']['ab_testing']['name'] : $optin_fire['name'],
								'optin_fire_type'	=> $optin_fire['type'],
								'row_class'			=> $row_class,
								'test'				=> isset($optin_fire['args']['ab_testing']['active']) && $optin_fire['args']['ab_testing']['active'] ? true : false,
								'test_on'			=> isset($optin_fire['args']['ab_testing']['on']) && $optin_fire['args']['ab_testing']['on'] ? true : false,
								'date'				=> $stat['date'],
								'impressions'		=> isset($optin_fire_stats[$optin_fire['id']]['impressions']) ?
													   $optin_fire_stats[$optin_fire['id']]['impressions'] + $stat['impressions'] :
													   $stat['impressions'],
								'conversions'		=> isset($optin_fire_stats[$optin_fire['id']]['conversions']) ?
													   $optin_fire_stats[$optin_fire['id']]['conversions'] + $stat['conversions'] :
													   $stat['conversions'],
							);
						}
					}
				}
			}

			$impressions_total = 0;
			$conversions_total = 0;
			foreach ($optin_fire_stats as $optin_fire_stat) {
			    $impressions_total += $optin_fire_stat['impressions'];
			    $conversions_total += $optin_fire_stat['conversions'];
			}

			$ctr = $impressions_total != 0 ? round(($conversions_total/$impressions_total) * 100,2) : 0;

			$stats_content = '
			<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-total-container col-sm-12">
				<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals col-sm-4">
					<div class="'  . NNRobots_Optin_Fire::$prefix_dash . 'stats-impressions-total">
						<span>' . __('Impressions', NNRobots_Optin_Fire::$text_domain) . '</span>
						<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals-text">' . number_format($impressions_total) . '</div>
						<i class="fa fa-globe"></i>
					</div>
				</div>
				<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals col-sm-4">
					<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-conversions-total">
						<span>' . __('Conversions', NNRobots_Optin_Fire::$text_domain) . '</span>
						<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals-text">' . number_format($conversions_total) . '</div>
						<i class="fa fa-certificate"></i>
					</div>
				</div>
				<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals col-sm-4">
					<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-conversion-rate-total">
						<span>' .  __('Conversion Rate', NNRobots_Optin_Fire::$text_domain) . '</span>
						<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals-text">' . $ctr . '%</div>
						<i class="fa fa-usd"></i>
					</div>
				</div>
			</div>

			<div class="clearfix"></div>

			<div class="col-sm-6 ' . NNRobots_Optin_Fire::$prefix_dash . 'stats-table-container">

				<h3 id="nnr-heading" class="text-center">' . __('Total Stats', NNRobots_Optin_Fire::$text_domain) . '</h3>

				<table class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-table table sortable">

					<thead>
						<tr>
							<th>' . __('Optin', NNRobots_Optin_Fire::$text_domain) . '</th>
							<th class="' . NNRobots_Optin_Fire::$prefix_dash . 'impressions-key">' . __('Impressions', NNRobots_Optin_Fire::$text_domain) . '</th>
							<th class="' . NNRobots_Optin_Fire::$prefix_dash . 'conversions-key">' . __('Conversions', NNRobots_Optin_Fire::$text_domain) . '</th>
							<th data-defaultsort="desc" class="' . NNRobots_Optin_Fire::$prefix_dash . 'conversion-rate-key">' . __('Conversion Rate', NNRobots_Optin_Fire::$text_domain) . '</th>
						</tr>
					</thead>
					<tbody>';

					if ( count($optin_fire_stats) < 1 ) {
						$stats_content .= '<tr><td>' . __('No Stats Data for this time period', NNRobots_Optin_Fire::$text_domain) . '</td></tr>';
					}

					foreach ($optin_fire_stats as $optin_fire_stat) {

						$icon = '';

						if ( $optin_fire_stat['test'] ) {
							if ( $optin_fire_stat['test_on'] ) {
								$icon = '';// '<i style="position: absolute;left: 28px;margin-top: 2px;" class="fa fa-cog fa-spin"></i>';
							} else {
								$icon = '';//'<i style="position: absolute;left: 28px;margin-top: 2px;" class="fa fa-cog"></i>';
							}
						}

						$ctr = $optin_fire_stat['impressions'] > 0 ? round(($optin_fire_stat['conversions'] / $optin_fire_stat['impressions']) * 100, 2) : '0';

						$stats_content .= '<tr class="' . $optin_fire_stat['row_class'] . '">
							<td> ' .  $icon . '
								<a href="' . admin_url() . 'admin.php?page=' . NNRobots_Optin_Fire::$stats_page . '&optin_fire_id=' . $optin_fire_stat['optin_fire_id'] . '&optin_fire_name=' . $optin_fire_stat['optin_fire_name'] . '" class="">
									' . $optin_fire_stat['optin_fire_name'] . '
								</a>
							</td>
							<td>' . number_format($optin_fire_stat['impressions']) . '</td>';
							$stats_content .= '
							<td>' . number_format($optin_fire_stat['conversions']) . '</td>
							<td data-value="' . $ctr . '" class="conversions column-conversions">' . $ctr . '%</td>';

						$stats_content .= '</tr>';
					}

				$stats_content .= '</tbody>
				</table>
			</div>

			<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'conversion-chart col-sm-6">

				<h3 id="nnr-heading" class="text-center">' . __('Conversion Distribution', NNRobots_Optin_Fire::$text_domain) . '</h3>

				<div class="col-sm-12">
					<canvas id="' . NNRobots_Optin_Fire::$prefix_dash . 'pie-chart"></canvas>
				</div>

				<ul class="col-sm-12 ' . NNRobots_Optin_Fire::$prefix_dash . 'pie-chart-legend-colors">';

				$counter = 0;

					foreach ($optin_fire_stats as $optin_fire_stat) {

						if ( $optin_fire_stat['conversions'] < 1 ) {
							continue;
						}

						$icon = '';

						if ( $optin_fire_stat['test'] && $optin_fire_stat['test_on'] ) {
							//$icon = '<i style="margin-right: 6px;" class="fa fa-cog fa-spin"></i>';
						} else if ( $optin_fire_stat['test'] ) {
							//$icon = '<i style="margin-right: 6px;" class="fa fa-cog"></i>';
						}

						$stats_content .= '<li class="' . NNRobots_Optin_Fire::$prefix_dash . 'pie-chart-legend-item">
							<span class="' . NNRobots_Optin_Fire::$prefix_dash . 'pie-chart-legend-color" style="background-color:' . self::$pie_chart_colors[$counter%count(self::$pie_chart_colors)] . '"></span>
							<span class="' . NNRobots_Optin_Fire::$prefix_dash . 'pie-chart-optin-name"> ' .  $icon . ' ' . $optin_fire_stat['optin_fire_name'] . '</span>
						</li>';

						$counter++;
					}

				$stats_content .= '</ul>
			</div>';
		}

		// Single optin stats

		else if (isset($_POST['optin_fire_id']) && $_POST['optin_fire_id'] != 'false') {

			$optin_fire_stats = NNRobots_Stats_OF::getStats($start_date, $end_date, $_POST['optin_fire_id']);
			$optin_fire = $db->get_data_from_id($_POST['optin_fire_id']);

			// Check if optin fire is in an A/B Test

			if ( isset($optin_fire['args']['ab_testing']['active']) && $optin_fire['args']['ab_testing']['active'] &&
			 	 isset($optin_fire['args']['ab_testing']['is_variant']) && !$optin_fire['args']['ab_testing']['is_variant'] ) {

				$stats = NNRobots_Stats_OF::getStats($start_date, $end_date);
				$optin_fires = array($optin_fire);
				$optin_fire_stats = array();

				foreach ( $optin_fire['args']['ab_testing']['children'] as $child ) {
					$optin_fires[] = $db->get_data_from_id($child);
				}

		 	 	foreach ($optin_fires as $optin_fire) {
					foreach ($stats as $stat) {

						if ( $optin_fire['id'] == $stat['optin_fire_id']) {

							// Active

							if ( $optin_fire['active'] == 'Active' &&
								( !isset($optin_fire['args']['ab_testing']['active']) || ( isset($optin_fire['args']['ab_testing']['active']) && !$optin_fire['args']['ab_testing']['active'] ) )) {
								$row_class = NNRobots_Optin_Fire::$prefix_dash . 'active-row';
							}

							// Test

							else if ( $optin_fire['active'] == 'Active' && isset($optin_fire['args']['ab_testing']['active']) && $optin_fire['args']['ab_testing']['active'] ) {
								$row_class = NNRobots_Optin_Fire::$prefix_dash . 'test-row';
							}

							// Inactive

							else {
								$row_class = NNRobots_Optin_Fire::$prefix_dash . 'inactive-row';
							}

							$optin_fire_stats[$optin_fire['id']] = array(
								'optin_fire_id'		=> $stat['optin_fire_id'],
								'optin_fire_name'	=> $optin_fire['name'],
								'optin_fire_type'	=> $optin_fire['type'],
								'row_class'			=> $row_class,
								'test'				=> isset($optin_fire['args']['ab_testing']['active']) && $optin_fire['args']['ab_testing']['active'] ? true : false,
								'date'				=> $stat['date'],
								'impressions'		=> isset($optin_fire_stats[$optin_fire['id']]['impressions']) ? $optin_fire_stats[$optin_fire['id']]['impressions'] + $stat['impressions'] : $stat['impressions'],
								'conversions'			=> isset($optin_fire_stats[$optin_fire['id']]['conversions']) ? $optin_fire_stats[$optin_fire['id']]['conversions'] + $stat['conversions'] : $stat['conversions'],
							);
						}
					}
				}

				$impressions_total = 0;
				$conversions_total = 0;
				foreach ($optin_fire_stats as $optin_fire_stat) {
				    $impressions_total += $optin_fire_stat['impressions'];
				    $conversions_total += $optin_fire_stat['conversions'];
				}

				$ctr = $impressions_total != 0 ? round(($conversions_total/$impressions_total) * 100,2) : 0;

				$stats_content = '
				<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-total-container col-sm-12">
					<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals col-sm-4">
						<div class="'  . NNRobots_Optin_Fire::$prefix_dash . 'stats-impressions-total">
							<span>' . __('Impressions', NNRobots_Optin_Fire::$text_domain) . '</span>
							<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals-text">' . number_format($impressions_total) . '</div>
							<i class="fa fa-globe"></i>
						</div>
					</div>
					<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals col-sm-4">
						<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-conversions-total">
							<span>' . __('Conversions', NNRobots_Optin_Fire::$text_domain) . '</span>
							<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals-text">' . number_format($conversions_total) . '</div>
							<i class="fa fa-certificate"></i>
						</div>
					</div>
					<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals col-sm-4">
						<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-conversion-rate-total">
							<span>' .  __('Conversion Rate', NNRobots_Optin_Fire::$text_domain) . '</span>
							<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals-text">' . $ctr . '%</div>
							<i class="fa fa-usd"></i>
						</div>
					</div>
				</div>

				<div class="clearfix"></div>

				<div class="col-sm-6 ' . NNRobots_Optin_Fire::$prefix_dash . 'stats-table-container">

					<h3 id="nnr-heading" class="text-center">' . __('Total Stats', NNRobots_Optin_Fire::$text_domain) . '</h3>

					<table class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-table table sortable">

						<thead>
							<tr>
								<th>' . __('Optin', NNRobots_Optin_Fire::$text_domain) . '</th>
								<th class="' . NNRobots_Optin_Fire::$prefix_dash . 'impressions-key">' . __('Impressions', NNRobots_Optin_Fire::$text_domain) . '</th>
								<th class="' . NNRobots_Optin_Fire::$prefix_dash . 'conversions-key">' . __('Conversions', NNRobots_Optin_Fire::$text_domain) . '</th>
								<th data-defaultsort="desc" class="' . NNRobots_Optin_Fire::$prefix_dash . 'conversion-rate-key">' . __('Conversion Rate', NNRobots_Optin_Fire::$text_domain) . '</th>
							</tr>
						</thead>
						<tbody>';

						if ( count($optin_fire_stats) < 1 ) {
							$stats_content .= '<tr><td>' . __('No Stats Data for this time period', NNRobots_Optin_Fire::$text_domain) . '</td></tr>';
						}

						foreach ($optin_fire_stats as $optin_fire_stat) {

							$icon = '';

							if ( $optin_fire_stat['test'] ) {
								$icon = '<i style="position: absolute;left: 28px;margin-top: 2px;" class="fa fa-code-fork"></i>';
							}

							$ctr = $optin_fire_stat['impressions'] > 0 ? round(($optin_fire_stat['conversions'] / $optin_fire_stat['impressions']) * 100, 2) : '0';

							$stats_content .= '<tr class="' . $optin_fire_stat['row_class'] . '">
								<td> ' .  $icon . ' ' . $optin_fire_stat['optin_fire_name'] . '</td>
								<td data-value="' . $optin_fire_stat['impressions'] .'">' . number_format($optin_fire_stat['impressions']) . '</td>
								<td data-value="' . $optin_fire_stat['conversions'] . '">' . number_format($optin_fire_stat['conversions']) . '</td>
								<td data-value="' . $ctr . '" class="conversions column-conversions">' . $ctr . '%</td>';

							$stats_content .= '</tr>';
						}

					$stats_content .= '</tbody>
					</table>
				</div>

				<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'conversion-chart col-sm-6">

					<h3 id="nnr-heading" class="text-center">' . __('Conversion Distribution', NNRobots_Optin_Fire::$text_domain) . '</h3>

					<div class="col-sm-12">
						<canvas id="' . NNRobots_Optin_Fire::$prefix_dash . 'pie-chart"></canvas>
					</div>

					<ul class="col-sm-12 ' . NNRobots_Optin_Fire::$prefix_dash . 'pie-chart-legend-colors">';

					$counter = 0;

						foreach ($optin_fire_stats as $optin_fire_stat) {

							if ( $optin_fire_stat['conversions'] < 1 ) {
								continue;
							}

							$icon = '';

							if ( $optin_fire_stat['test'] ) {
								$icon = '<i style="padding-right: 6px;" class="fa fa-code-fork"></i>';
							}

							$stats_content .= '<li class="' . NNRobots_Optin_Fire::$prefix_dash . 'pie-chart-legend-item">
								<span class="' . NNRobots_Optin_Fire::$prefix_dash . 'pie-chart-legend-color" style="background-color:' . self::$pie_chart_colors[$counter%count(self::$pie_chart_colors)] . '"></span>
								<span class="' . NNRobots_Optin_Fire::$prefix_dash . 'pie-chart-optin-name"> ' .  $icon . ' ' . $optin_fire_stat['optin_fire_name'] . '</span>
							</li>';

							$counter++;
						}

					$stats_content .= '</ul>
				</div>';

				echo json_encode(array('stats_content' => $stats_content, 'optin_fire_stats' => $optin_fire_stats, 'optin_fire' => $db->get_data_from_id($_POST['optin_fire_id'])));

				die(); // this is required to terminate immediately and return a proper response

			} else {

				foreach ($optin_fire_stats as $key => $optin_fire_stat) {
					$optin_fire_stats[$key] = array('optin_fire_name' => $optin_fire['name']) + $optin_fire_stats[$key] + array('optin_fire_type' => $optin_fire['type']);
				}

				// Unset indesm

				foreach ($optin_fire_stats as $key => $optin_fire_stat) {
					unset($optin_fire_stats[$key]['id']);
					unset($optin_fire_stats[$key]['optin_fire_id']);
				}

				$impressions_total = 0;
				$conversions_total = 0;
				foreach ($optin_fire_stats as $optin_fire_stat) {
				    $impressions_total += $optin_fire_stat['impressions'];
				    $conversions_total += $optin_fire_stat['conversions'];
				}

				$ctr = $impressions_total != 0 ? round(($conversions_total/$impressions_total) * 100,2) : 0;

				$stats_content = '<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-total-container col-sm-12">
					<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals col-sm-4">
						<div class="'  . NNRobots_Optin_Fire::$prefix_dash . 'stats-impressions-total">
							<span>' . __('Impressions', NNRobots_Optin_Fire::$text_domain) . '</span>
							<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals-text">' . number_format($impressions_total) . '</div>
							<i class="fa fa-globe"></i>
						</div>
					</div>
					<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals col-sm-4">
						<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-conversions-total">
							<span>' . __('Conversions', NNRobots_Optin_Fire::$text_domain) . '</span>
							<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals-text">' . number_format($conversions_total) . '</div>
							<i class="fa fa-certificate"></i>
						</div>
					</div>
					<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals col-sm-4">
						<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-conversion-rate-total">
							<span>' .  __('Conversion Rate', NNRobots_Optin_Fire::$text_domain) . '</span>
							<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'stats-totals-text">' . $ctr . '%</div>
							<i class="fa fa-usd"></i>
						</div>
					</div>
				</div>

				<div class="clearfix"></div>

				<div class="col-sm-6 table-responsive">

					<h3 id="nnr-heading" class="text-center">' . __('Total Stats', NNRobots_Optin_Fire::$text_domain) . '</h3>

					<table class="table sortable">

						<thead>
							<th data-defaultsort="desc">' . __('Date', NNRobots_Optin_Fire::$text_domain) . '</th>
							<th class="' . NNRobots_Optin_Fire::$prefix_dash . 'impressions-key">' . __('Impressions', NNRobots_Optin_Fire::$text_domain) . '</th>
							<th class="' . NNRobots_Optin_Fire::$prefix_dash . 'conversions-key">' . __('Conversions', NNRobots_Optin_Fire::$text_domain) . '</th>
							<th class="' . NNRobots_Optin_Fire::$prefix_dash . 'conversion-rate-key">' . __('Conversion Rate', NNRobots_Optin_Fire::$text_domain) . '</th>
						</thead>';

						foreach (array_reverse($optin_fire_stats) as $optin_fire_stat) {

							$ctr = $optin_fire_stat['impressions'] > 0 ? round(($optin_fire_stat['conversions'] / $optin_fire_stat['impressions']) * 100, 2) : '0';

							$stats_content .= '<tr>
								<td data-value="' . strtotime($optin_fire_stat['date']) . '">' . date('M j Y', strtotime($optin_fire_stat['date'])) . '</td>
								<td data-value="' . $optin_fire_stat['impressions'] . '">' . number_format($optin_fire_stat['impressions']) . '</td>
								<td data-value="' . $optin_fire_stat['conversions'] . '">' . number_format($optin_fire_stat['conversions']) . '</td>
								<td data-value="' . $ctr . '" class="conversions column-conversions">' . $ctr . '%</td>';

							$stats_content .= '</tr>';
						}

					$stats_content .= '</table>
				</div>

				<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'line-graph-container col-sm-6">

					<h3 id="nnr-heading" class="text-center">' . __('Impressions and Conversions', NNRobots_Optin_Fire::$text_domain) . '</h3>

					<canvas id="' . NNRobots_Optin_Fire::$prefix_dash . 'line-graph"></canvas>
				</div>';
			}
		}

		echo json_encode(array('stats_content' => $stats_content, 'optin_fire_stats' => $optin_fire_stats));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Load all emails using ajax to make back-end more responsive
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function emails_load() {

		// Includes

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . "core/model/email-signups.php");
		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . "admin/model/db.php");

		require_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/includes/php-pretty-datetime/PrettyDateTime.php');

		$db = new NNRobots_Optin_Fire_DB();
		$optin_fires = $db->get_optin_fires();

		// Get Start and End Dates

		$start_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
		$end_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, mktime(59, 59, 23, date("m"), date("d"), date("Y")));

		$post_start_date = urldecode($_POST['start_date']);
		$post_end_date = urldecode($_POST['end_date']);

		if (isset($post_start_date) && $post_start_date != '') {
			$start_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, strtotime($post_start_date));
		}

		if (isset($post_end_date) && $post_end_date != '') {

			$temp_end_date = strtotime($post_end_date);

			$end_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, mktime(59, 59, 23, date("m", $temp_end_date), date("d", $temp_end_date), date("Y", $temp_end_date)));
		}

		// Get Emails

		global $wpdb;

		$now = new DateTime();

		$emails = NNRobots_Email_Signups_OF::getEmails($start_date, $end_date);

		foreach ($emails as $key => $email) {
			$emails[$key]['optin_fire_name'] = 'DELETED';
		}

		foreach ($optin_fires as $optin_fire) {
			foreach ($emails as $key => $email) {
				if ($optin_fire['id'] == $email['optin_fire_id']) {
					$emails[$key] = array(
						'optin_fire_id'		=> $email['optin_fire_id'],
						'optin_fire_name'	=> $optin_fire['name'],
						'date'				=> $email['date'],
						'email'				=> $email['email'],
						'first_name'		=> $email['first_name'],
						'last_name'			=> $email['last_name'],
					);
				}
			}
		}

		$emails_content = '<div class="col-sm-12" style="padding-left: 0px; padding-right: 0px;">
			<table class="table table-condensed table-striped sortable">

				<thead>
					<th>' . __('Email', NNRobots_Optin_Fire::$text_domain) . '</th>
					<th>' . __('First Name', NNRobots_Optin_Fire::$text_domain) . '</th>
					<th>' . __('Last Name', NNRobots_Optin_Fire::$text_domain) . '</th>
					<th data-defaultsort="desc">' . __('Date Added', NNRobots_Optin_Fire::$text_domain) . '</th>
					<th>' . __('Optin', NNRobots_Optin_Fire::$text_domain) . '</th>
				</thead>';

				if (count($emails) < 1) {
					$emails_content .= '<tr>
						<td>' . __('No emails yet', NNRobots_Optin_Fire::$text_domain) . '</td>
						<td></td>
						<td></td>
						<td></td>
						<td></td>
					</tr>';
				} else {
					foreach (array_reverse($emails) as $optin_fire_email) {

						$dateTime = new DateTime($optin_fire_email['date']);

						$emails_content .= '<tr class="' . NNRobots_Optin_Fire::$prefix_dash . 'email-row">
							<td>' . $optin_fire_email['email'] . '</td>
							<td>' . $optin_fire_email['first_name'] . '</td>
							<td>' . $optin_fire_email['last_name'] . '</td>
							<td data-value="' . strtotime($optin_fire_email['date']) . '">' . PrettyDateTime::parse($dateTime, $now) . '</td>
							<td>' . ( $optin_fire_email['optin_fire_name'] != 'DELETED' ? $optin_fire_email['optin_fire_name'] : '<strong class="text-danger">' . $optin_fire_email['optin_fire_name'] . '</strong>' )  . '</td>
						</tr>';

					}
				}

			$emails_content .= '</table>
		</div>';

		echo $emails_content;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Load all emails using ajax to make back-end more responsive
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function entries_load() {

		// Includes

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/model/db.php');
		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'core/model/email-entries.php');

		require_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/includes/php-pretty-datetime/PrettyDateTime.php');

		$db = new NNRobots_Optin_Fire_DB();
		$optin_fires = $db->get_optin_fires();

		$entries_content = '';

		// Get Start and End Dates

		$start_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
		$end_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, mktime(59, 59, 23, date("m"), date("d"), date("Y")));

		$post_start_date = urldecode($_POST['start_date']);
		$post_end_date = urldecode($_POST['end_date']);

		if (isset($post_start_date) && $post_start_date != '') {
			$start_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, strtotime($post_start_date));
		}

		if (isset($post_end_date) && $post_end_date != '') {

			$temp_end_date = strtotime($post_end_date);

			$end_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, mktime(59, 59, 23, date("m", $temp_end_date), date("d", $temp_end_date), date("Y", $temp_end_date)));
		}

		// Get Entries

		global $wpdb;

		$entries = NNRobots_Email_Entries_OF::getEntries($start_date, $end_date);

		foreach ($entries as $key => $email) {
			$entries[$key]['optin_fire_name'] = '<strong style="color:red;">' . __('OPTIN DELETED', NNRobots_Optin_Fire::$text_domain) . '</strong>';
		}

		foreach ($optin_fires as $optin_fire) {
			foreach ($entries as $key => $entry) {
				if ($optin_fire['id'] == $entry['optin_fire_id']) {
					$entries[$key]['optin_fire_name'] = $optin_fire['name'];
				}
			}
		}

		$now = new DateTime();

		if (count($entries) < 1) {
			$entries_content .= '<tr>
				<td>' . __('No entries found', NNRobots_Optin_Fire::$text_domain) . '</td>
			</tr>';
		} else {

		$entries_content = '<div class="col-sm-12" style="padding-left: 0px; padding-right: 0px;">
			<div class="col-sm-4 ' . NNRobots_Optin_Fire::$prefix_dash . 'entry-list">
				<table class="table table-condensed table-hover">';


						foreach (array_reverse($entries) as $entry) {

							if ( !isset($entry_id) ) {
								$entry_id = $entry['id'];
							}

							$dateTime = new DateTime($entry['date']);

							$message = $entry['message'];

							if ( strlen($message) > 100 ) {
								$message = substr($message, 0, 50) . ' ...';
							}

							$entries_content .= '<tr class="' . NNRobots_Optin_Fire::$prefix_dash . 'entry-row" data-entry-id="' . $entry['id'] . '">
								<td>
									<div class="col-sm-12">
										<span class="' . NNRobots_Optin_Fire::$prefix_dash . 'entry-email pull-left">' . $entry['email'] . '</span>
										<span class="' . NNRobots_Optin_Fire::$prefix_dash . 'entry-date pull-right"><em>' . PrettyDateTime::parse($dateTime, $now) . '</em></span>
									</div>
									<div class="col-sm-12">
										<span class="' . NNRobots_Optin_Fire::$prefix_dash . 'entry-subject pull-left">' . $entry['subject'] . '</span>
										<span class="' . NNRobots_Optin_Fire::$prefix_dash . 'entry-optin pull-right">' . $entry['optin_fire_name'] . '</span>
									</div>
									<div class="col-sm-12">
										<p class="' . NNRobots_Optin_Fire::$prefix_dash . 'entry-message"><em>' . $message . '</em></p>
									</div>
								</td>
							</tr>';

						}


			$entries_content .= '
				</table>
			</div>
			<div class="col-sm-8 ' . NNRobots_Optin_Fire::$prefix_dash . 'single-entry" data-entry-id="' . $entry_id . '"></div>
		</div>';

		}

		echo $entries_content;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get the data for a single entry
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function entry_load() {

		// Check if their is an entry id

		if ( !isset($_POST['entry_id']) ) {
			echo '';
			die();
		}

		require_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/includes/php-pretty-datetime/PrettyDateTime.php');
		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/model/db.php');

		// Get Entry Data

		global $wpdb;

		$db = new NNRobots_Optin_Fire_DB();
		$optin_fires = $db->get_optin_fires();

		$entry = NNRobots_Email_Entries_OF::getEntry($_POST['entry_id']);

		$entry = $entry[0];

		$now = new DateTime();
		$dateTime = new DateTime($entry['date']);

		$entry['optin_fire_name'] = '<strong style="color:red;">' . __('OPTIN DELETED', NNRobots_Optin_Fire::$text_domain) . '</strong>';

		foreach ($optin_fires as $optin_fire) {
			if ($optin_fire['id'] == $entry['optin_fire_id']) {
				$entry['optin_fire_name'] = $optin_fire['name'];
			}
		}

		$entry_content = '<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'entry-container">

			<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'entry-header-data">
				<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'entry-info-email">' . $entry['email'] . '<span class="' . NNRobots_Optin_Fire::$prefix_dash . 'entry-date pull-right"><em>' . PrettyDateTime::parse($dateTime, $now) . '</em></span></div>
				<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'entry-info-subject">
					<span>' . $entry['subject'] . '</span>
					<span class="' . NNRobots_Optin_Fire::$prefix_dash . 'entry-optin pull-right">' . $entry['optin_fire_name'] . '</span>
				</div>
			</div>

			<p class="' . NNRobots_Optin_Fire::$prefix_dash . 'entry-info-message">' . $entry['message'] . '</p>

		</div>';

		echo $entry_content;

		die();

	}

	/**
	 * Everyday check if there is a record for impressions or conversions for each fireabr.
	 * If there is no record than add one and set it to 0..
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function initialize_optin_fire_stats_daily() {

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . "core/model/stats.php");

		NNRobots_Stats_OF::initialize_optin_fire_stats();
	}

	/**
	 * Email the weekly Optin Stats to the admin account
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function setup_optin_fire_email_stats() {

		$global_settings = get_option(NNRobots_Optin_Fire::$prefix . 'global_settings');

		if ( $global_settings === false ) {
			$global_settings = self::default_global_settings();
		}

		if (!$global_settings['send_weekly_email']) {
			return false;
		}

		// Comment this out for testing

		if (date('N') != 7) {
			return false;
		}

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . "core/model/stats.php");
		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . "admin/model/db.php");

		global $wpdb;

		$admins = get_users('role=administrator');

		$start_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, mktime(0, 0, 0, date("m"), date("d")-7, date("Y")));
		$end_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, strtotime(current_time('mysql')));

		$stats = NNRobots_Stats_OF::getStats($start_date, $end_date);
		$optin_fires = $wpdb->get_results("SELECT * FROM `" . NNRobots_Optin_Fire_DB::getTableName() . "`");
		$optin_fire_stats = array();

		foreach ($optin_fires as $optin_fire) {
			foreach ($stats as $stat) {
				if ($optin_fire->id == $stat['optin_fire_id']) {
					$optin_fire_stats[$optin_fire->id] = array(
						'optin_fire_id'		=> $stat['optin_fire_id'],
						'optin_fire_name'	=> $optin_fire->name,
						'optin_fire_type'	=> $optin_fire->template,
						'date'			=> $stat['date'],
						'impressions'	=> isset($optin_fire_stats[$optin_fire->id]['impressions']) ? $optin_fire_stats[$optin_fire->id]['impressions'] + $stat['impressions'] : $stat['impressions'],
						'conversions'		=> isset($optin_fire_stats[$optin_fire->id]['conversions']) ? $optin_fire_stats[$optin_fire->id]['conversions'] + $stat['conversions'] : $stat['conversions'],
					);
				}
			}
		}

		$impressions_total = 0;
		$conversions_total = 0;
		foreach ($optin_fire_stats as $optin_fire_stat) {
		    $impressions_total += $optin_fire_stat['impressions'];
		    $conversions_total += $optin_fire_stat['conversions'];
		}

		$subject = __('Weekly Optin Stats!', NNRobots_Optin_Fire::$text_domain);

		$head = '<html>
			<head></head>';

		$body = '<body>

				<img src="' . NNROBOTS_OPTIN_FIRE_PLUGIN_URL . '/img/rainbow-strip-hz-wide.png" style="width: 100%;"/>

				<h1>' . __('Optin Weekly Stats', NNRobots_Optin_Fire::$text_domain) . '</h1>
				<h1>' . date('M j', strtotime($start_date)) . ' - ' . date('M j', strtotime($end_date)) . '</h1>

				<div style="min-height: 20px;
					  padding: 19px;
					  margin-bottom: 20px;
					  background-color: #f5f5f5;
					  border: 1px solid #e3e3e3;
					  border-radius: 4px;
					  -webkit-box-shadow: inset 0 1px 1px rgba(0, 0, 0, .05);
					          box-shadow: inset 0 1px 1px rgba(0, 0, 0, .05);">

					<table style="width:100%; border: none;">

						<col width="33.33%">
						<col width="33.33%">
						<col width="33.33%">

						<thead style="border: none;">
							<th style="border: none;">' . __('Impressions', NNRobots_Optin_Fire::$text_domain) . '</th>
							<th style="border: none;">' . __('Conversions', NNRobots_Optin_Fire::$text_domain) . '</th>
							<th style="border: none;">' .  __('Conversion Rate', NNRobots_Optin_Fire::$text_domain) . '</th>
						</thead>

						<tr style="border: none;">
							<td style="border: none; background: transparent; text-align: center; font-size: 60px;">' . number_format($impressions_total) . '</td>
							<td style="border: none; background: transparent; text-align: center; font-size: 60px;">' . number_format($conversions_total) . '</td>
							<td style="border: none; background: transparent; text-align: center; font-size: 60px;">' . round(($conversions_total/$impressions_total) * 100,2) . '%</td>
						</tr>
					</table>

				</div>
				<table style="width: 100%;
					max-width: 100%;
					margin-bottom: 20px;">

					<thead style="border: 1px solid #ddd;">
						<th style="vertical-align: bottom;
							border-bottom: 2px solid #ddd;padding: 8px;
							line-height: 1.42857143;
							vertical-align: top;">' . __('Optin', NNRobots_Optin_Fire::$text_domain) . '</th>
						<th style="vertical-align: bottom; border-bottom: 2px solid #ddd;padding: 8px;
							line-height: 1.42857143;
							vertical-align: top;">' . __('Impressions', NNRobots_Optin_Fire::$text_domain) . '</th>
						<th style="vertical-align: bottom; border-bottom: 2px solid #ddd;padding: 8px;
						  	line-height: 1.42857143;
						  	vertical-align: top;">' . __('Conversions', NNRobots_Optin_Fire::$text_domain) . '</th>
						<th style="vertical-align: bottom; border-bottom: 2px solid #ddd;padding: 8px;
						  	line-height: 1.42857143;
						  	vertical-align: top;">' . __('Conversion Rate', NNRobots_Optin_Fire::$text_domain) . '</th>
					</thead>';

					foreach ($optin_fire_stats as $optin_fire_stat) {

						$body .= '<tr style="border: 1px solid #ddd;text-align:center;">
							<td>
								<a style="
								  color: white;
								  text-decoration: none;
								  color: #fff;
								  cursor: pointer;
								display: inline-block;
								font-family: \'Helvetica Neue\', Helvetica, Arial, sans-serif;
								font-size: 12px;
								font-stretch: normal;
								font-style: normal;
								font-variant: normal;
								font-weight: normal;
								height: 18px;
								letter-spacing: normal;
								line-height: 18px;
								margin-bottom: 0px;
								margin-left: 0px;
								margin-right: 0px;
								margin-top: 0px;
								overflow-x: visible;
								overflow-y: visible;
								padding-bottom: 1px;
								padding-left: 5px;
								padding-right: 5px;
								padding-top: 1px;
								  background-color: #337ab7;
								  border-color: #2e6da4;
								  -webkit-border-radius: 3px;
								  -moz-border-radius: 3px;
								  border-radius: 3px;" href="' . admin_url() . 'admin.php?page=' . NNRobots_Optin_Fire::$stats_page . '&optin_fire_id=' . $optin_fire_stat['optin_fire_id'] . '&optin_fire_name=' . $optin_fire_stat['optin_fire_name'] . '">
									' .  $optin_fire_stat['optin_fire_name'] . '
								</a>
							</td>
							<td>' . number_format($optin_fire_stat['impressions']) . '</td>';

							if ($optin_fire_stat['optin_fire_type'] == 'Text') {
								$body .= '
								<td>' . __('N/A', NNRobots_Optin_Fire::$text_domain) . '</td>
								<td>' . __('N/A', NNRobots_Optin_Fire::$text_domain) . '</td>';
							} else {
								$body .= '
								<td>' . number_format($optin_fire_stat['conversions']) . '</td>
								<td>' . ($optin_fire_stat['impressions'] > 0 ? round(($optin_fire_stat['conversions'] / $optin_fire_stat['impressions']) * 100, 2) : '0') . '%</td>';
							}

						$body .= '</tr>';
					}

			$body .= '</table>
			</body>';

		$foot = '
			<br/>
			<br/>
			<br/>
			<p style="text-align: center;"><a href="https://99robots.com">' . __('Visit', NNRobots_Optin_Fire::$text_domain) . '</a> ' . __('our site to read about all the latest WordPress News.', NNRobots_Optin_Fire::$text_domain) . '</p>
		</html>';

		$message = $head . $body . $foot;
		$headers = array('Content-Type: text/html; charset=UTF-8');

		foreach ( $admins as $admin ) {
			$result = wp_mail($admin->user_email, $subject, $message, $headers);
		}
	}

	/**
	 * Get all Posts in post type
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_posts() {

		echo json_encode(get_posts('posts_per_page=-1&post_type=' . $_POST['post_type']));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Categories
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_categories() {

		echo json_encode(get_categories());

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Tags
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_tags() {

		echo json_encode(get_tags());

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all MailChimp Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_mailchimp_lists() {

		$options = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '') {
			require_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'core/includes/mailchimp/MailChimp.php');

			$MailChimp = new WPS_MailChimp($_POST['api_key']);
			$lists = $MailChimp->call('lists/list');

			if (isset($lists) && is_array($lists)) {

				foreach ($lists['data'] as $list) {
					$options .= '<option value="' . $list['id'] . '">' .  $list['name'] . '</option>';
				}

				if (isset($_POST['list']) && $_POST['list'] != '') {
					$options = '';

					foreach ($lists['data'] as $list) {
						if ($_POST['list'] == $list['id']) {
							$options .= '<option value="' . $list['id'] . '" selected="selected">' .  $list['name'] . '</option>';
						} else {
							$options .= '<option value="' . $list['id'] . '">' .  $list['name'] . '</option>';
						}
					}
				}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get the Aweber lists for an account
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_aweber_lists() {

		$options = '';
		$consumerKey = '';
		$consumerSecret = '';
		$accessKey = '';
		$accessSecret = '';

		if (isset($_POST['code']) && $_POST['code'] != '') {

			require_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'core/includes/aweber/aweber_api.php');
			include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/model/db.php');

			try {
				$credentials = AWeberAPI::getDataFromAweberID($_POST['code']);
				list($consumerKey, $consumerSecret, $accessKey, $accessSecret) = $credentials;


				$consumerKey    = isset($consumerKey) && !empty($consumerKey) ? $consumerKey : '';
				$consumerSecret = isset($consumerSecret) && !empty($consumerSecret) ? $consumerSecret : '';
				$accessKey      = isset($accessKey) && !empty($accessKey) ? $accessKey : '';
				$accessSecret   = isset($accessSecret) && !empty($accessSecret) ? $accessSecret : '';

			} catch (AWeberAPIException $exc) {
				error_log($exc);
			}

			try {

				$aweber = new AWeberAPI($consumerKey, $consumerSecret);
				$account = $aweber->getAccount($accessKey, $accessSecret);
				$lists = $account->loadFromUrl('/accounts/' . $account->id . '/lists/');

				foreach ($lists as $list) {
					$options .= '<option value="' . $list->id . '">' .  $list->name . '</option>';
				}

			} catch (AWeberAPIException $exc) { error_log($exc); }
		}

		if (isset($_POST['list']) && $_POST['list'] != '') {

			$consumerKey     = $_POST['consumer_key'];
			$consumerSecret  = $_POST['consumer_secret'];
			$accessKey       = $_POST['access_key'];
			$accessSecret    = $_POST['access_secret'];

			require_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'core/includes/aweber/aweber_api.php');
			include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/model/db.php');

			try {

				$aweber = new AWeberAPI($consumerKey, $consumerSecret);
				$account = $aweber->getAccount($accessKey, $accessSecret);
				$lists = $account->loadFromUrl('/accounts/' . $account->id . '/lists/');

				$options = '';
				foreach ($lists as $list) {
					if ($_POST['list'] == $list->id) {
						$options .= '<option value="' . $list->id . '" selected="selected">' .  $list->name . '</option>';
					} else {
						$options .= '<option value="' . $list->id . '">' .  $list->name . '</option>';
					}
				}

			} catch (AWeberAPIException $exc) { error_log($exc); }
		}

		echo json_encode(array(
			'html'               => $options,
			'consumer_key'       => $consumerKey,
			'consumer_secret'    => $consumerSecret,
			'access_key'         => $accessKey,
			'access_secret'      => $accessSecret,
		));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Get Repsonse Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_getresponse_lists() {

		$options = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '') {

			require_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'core/includes/getresponse/jsonRPCClient.php');
			$api = new jsonRPCClient('http://api2.getresponse.com');

			try {
				$result = $api->get_campaigns($_POST['api_key']);
				foreach ((array) $result as $k => $v) {
					$campaigns[] = array('id' => $k, 'name' => $v['name']);
				}
			}

			catch (Exception $e) {}

			if (isset($campaigns) && is_array($campaigns)) {

				foreach ($campaigns as $campaign) {
					$options .= '<option value="' . $campaign['id'] . '">' .  $campaign['name'] . '</option>';
				}

				if (isset($_POST['campaign']) && $_POST['campaign'] != '') {
					$options = '';
					foreach ($campaigns as $campaign) {

						if ($_POST['campaign'] == $campaign['id']) {
							$options .= '<option value="' . $campaign['id'] . '" selected="selected">' .  $campaign['name'] . '</option>';
						} else {
							$options .= '<option value="' . $campaign['id'] . '">' .  $campaign['name'] . '</option>';
						}
					}
				}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Campaign Monitor Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_campaignmonitor_lists() {

		$lists = '';
		$clients = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '') {

			require_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'core/includes/campaignmonitor/csrest_general.php');
			require_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'core/includes/campaignmonitor/csrest_clients.php');
			$auth = array('api_key' => $_POST['api_key']);
			$wrap = new CS_REST_General($auth);
			$result = $wrap->get_clients();


			if ($result->was_successful()) {

				foreach ($result->response as $client) {
					$clients .= '<option value="' . $client->ClientID . '">' .  $client->Name . '</option>';
				}

				if (isset($_POST['client']) && $_POST['client'] != '') {
					$clients = '';
					foreach ($result->response as $client) {
						if ($_POST['client'] == $client->ClientID) {
							$clients .= '<option value="' . $client->ClientID . '" selected="selected">' .  $client->Name . '</option>';
						} else {
							$clients .= '<option value="' . $client->ClientID . '">' .  $client->Name . '</option>';
						}
					}
				}

				if (isset($_POST['client']) && $_POST['client'] != '') {
					$client_id = $_POST['client'];
				} else {
					$client_id = $result->response[0]->ClientID;
				}

				$wrap = new CS_REST_Clients($client_id, $_POST['api_key']);
				$result = $wrap->get_lists();

				if ($result->was_successful()) {
					foreach ($result->response as $list) {
						$lists .= '<option value="' . $list->ListID . '">' .  $list->Name . '</option>';
					}

					if (isset($_POST['list']) && $_POST['list'] != '') {
						$lists = '';
						foreach ($result->response as $list) {
							if ($_POST['list'] == $list->ListID) {
								$lists .= '<option value="' . $list->ListID . '" selected="selected">' .  $list->Name . '</option>';
							} else {
								$lists .= '<option value="' . $list->ListID . '">' .  $list->Name . '</option>';
							}
						}
					}
				}
			}
		}

		echo json_encode(array('clients' => $clients, 'lists' => $lists));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Update all Campaign Monitor Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function update_campaignmonitor_lists() {

		$lists = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '' &&
			isset($_POST['client_id']) && $_POST['client_id'] != '') {

			require_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'core/includes/campaignmonitor/csrest_general.php');
			require_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'core/includes/campaignmonitor/csrest_clients.php');


			$wrap = new CS_REST_Clients($_POST['client_id'], $_POST['api_key']);
			$result = $wrap->get_lists();


			if ($result->was_successful()) {
				foreach ($result->response as $list) {
					$lists .= '<option value="' . $list->ListID . '">' .  $list->Name . '</option>';
				}
			}
		}

		echo $lists;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Mad Mimi Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_madmimi_lists() {

		$options = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '' &&
			isset($_POST['username']) && $_POST['username'] != '') {

			require_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'core/includes/madmimi/MadMimi.class.php');

			$mailer = new MadMimi($_POST['username'], $_POST['api_key']);

			if (isset($mailer)) {
				try {
					$lists = $mailer->Lists();
					$lists  = new SimpleXMLElement($lists);

				    if ($lists->list) {
						foreach ($lists->list as $l) {
							$options .= '<option value="' . $l->attributes()->{'name'}->{0} . '">' .  $l->attributes()->{'name'}->{0} . '</option>';
						}
				    }

				    if (isset($_POST['list']) && $_POST['list'] != '') {
					    $options = '';
						foreach ($lists->list as $l) {

							if ($_POST['list'] == $l->attributes()->{'name'}->{0}) {
								$options .= '<option value="' . $l->attributes()->{'name'}->{0} . '" selected="selected">' .  $l->attributes()->{'name'}->{0} . '</option>';
							} else {
								$options .= '<option value="' . $l->attributes()->{'name'}->{0} . '">' .  $l->attributes()->{'name'}->{0} . '</option>';
							}
						}
					}
				} catch (Exception $exc) {}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all the infusionsoft lists for specfic account
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_infusionsoft_lists() {

		if ( ! function_exists( 'curl_init' ) ) {
			return __( 'curl_init is not defined ', 'bloom' );
		}

		if ( ! class_exists( 'iSDK' ) ) {
			require_once( NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'core/includes/infusionsoft/isdk.php' );
		}

		$options = '';

		// Make sure the use entered in the api key

		if (isset($_POST['app_id']) && $_POST['app_id'] != '' &&
			isset($_POST['api_key']) && $_POST['api_key'] != '') {

			try {
				$infusion_app = new iSDK();
				$infusion_app->cfgCon( $_POST['app_id'], $_POST['api_key'], 'throw' );
			} catch( iSDKException $e ){
				$error_message = $e->getMessage();
			}

			if ( empty( $error_message ) ) {
				$need_request = true;
				$page = 0;
				$all_lists = array();

				while ( true == $need_request ) {
					$error_message = 'success';
					$lists_data = $infusion_app->dsQuery( 'ContactGroup', 1000, $page, array( 'Id' => '%' ), array( 'Id', 'GroupName' ) );
					$all_lists = array_merge( $all_lists, $lists_data );

					if ( 1000 > count( $lists_data ) ) {
						$need_request = false;
					} else {
						$page++;
					}
				}
			}

			// Get all list information

			if ( ! empty( $all_lists ) ) {
				foreach( $all_lists as $list ) {

					if ($_POST['list'] == $list['Id']) {
						$options .= '<option value="' . $list['Id'] . '" selected="selected">' .  $list['GroupName'] . '</option>';
					} else {
						$options .= '<option value="' . $list['Id'] . '">' .  $list['GroupName'] . '</option>';
					}
				}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response

	}

	/**
	 * Get all the MyMail lists
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_mymail_lists() {

		if ( !function_exists('mymail') ) {
			echo '';
			die();
		}

		$lists = mymail('lists')->get();
		$options = '';

		foreach ( $lists as $list ) {
			if ($_POST['list'] == $list->ID) {
				$options .= '<option value="' . $list->ID . '" selected="selected">' .  $list->name . '</option>';
			} else {
				$options .= '<option value="' . $list->ID . '">' .  $list->name . '</option>';
			}
		}

		echo $options;
		die();
	}

	/**
	 * Get all the Active Campaign lists
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_activecampaign_lists() {

		require_once( NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'core/includes/activecampaign/ActiveCampaign.class.php' );

		$options = '';

		if ( isset($_POST['app_url']) && $_POST['app_url'] != '' &&
			isset($_POST['api_key']) && $_POST['api_key'] != '' ) {

			$ac = new ActiveCampaign($_POST['app_url'], $_POST['api_key']);

			if ( !(int)$ac->credentials_test() ) {

				echo "";
				exit();
			}

			$lists = $ac->api("list/list?ids=all");

			foreach ( $lists as $list ) {

				if ( !isset($list->id) || empty($list->id) ) {
					continue;
				}

				if ($_POST['list'] == $list->id) {
					$options .= '<option value="' . $list->id . '" selected="selected">' .  $list->name . '</option>';
				} else {
					$options .= '<option value="' . $list->id . '">' .  $list->name . '</option>';
				}
			}
		}

		echo $options;
		die();
	}

	/**
	 * Save the newsletter
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function default_newsletter() {

		$default_newsletter = get_option(NNRobots_Optin_Fire::$prefix . 'default_newsletter');

		if ( false === $default_newsletter ) {
			$default_newsletter = array(
				'type'	=> 'wordpress',
			);
		}

		$val = array();

		$default_newsletter['type']                				  = isset($_POST['type']) ? sanitize_text_field($_POST['type']) : '';

		// MailChimp

		$default_newsletter['mailchimp']['api_key']               = isset($_POST['mailchimp_api_key']) ? sanitize_text_field($_POST['mailchimp_api_key']) : '';

		$default_newsletter['mailchimp']['optin']                 = isset($_POST['mailchimp_optin']) && $_POST['mailchimp_optin'] == 'true' ? true : false;

		$default_newsletter['mailchimp']['list']                  = isset($_POST['mailchimp_list']) ? sanitize_text_field($_POST['mailchimp_list']) : '';

		// aweber

		$default_newsletter['aweber']['consumer_key']             = isset($_POST['aweber_consumer_key']) ? sanitize_text_field($_POST['aweber_consumer_key']) : '';

		$default_newsletter['aweber']['consumer_secret']          = isset($_POST['aweber_consumer_secret']) ? sanitize_text_field($_POST['aweber_consumer_secret']) : '';

		$default_newsletter['aweber']['access_key']               = isset($_POST['aweber_access_key']) ? sanitize_text_field($_POST['aweber_access_key']) : '';

		$default_newsletter['aweber']['access_secret']            = isset($_POST['aweber_access_secret']) ? sanitize_text_field($_POST['aweber_access_secret']) : '';

		$default_newsletter['aweber']['list_id']                  = isset($_POST['aweber_list_id']) ? sanitize_text_field($_POST['aweber_list_id']) : '';

		// Get Response

		$default_newsletter['getresponse']['api_key']             = isset($_POST['getresponse_api_key']) ? sanitize_text_field($_POST['getresponse_api_key']) : '';

		$default_newsletter['getresponse']['campaign']            = isset($_POST['getresponse_campaign']) ? sanitize_text_field($_POST['getresponse_campaign']) : '';

		// Campiagn Monitor

		$default_newsletter['campaignmonitor']['api_key']         = isset($_POST['campaignmonitor_api_key']) ? sanitize_text_field($_POST['campaignmonitor_api_key']) : '';

		$default_newsletter['campaignmonitor']['client']          = isset($_POST['campaignmonitor_client']) ? sanitize_text_field($_POST['campaignmonitor_client']) : '';

		$default_newsletter['campaignmonitor']['list']            = isset($_POST['campaignmonitor_list']) ? sanitize_text_field($_POST['campaignmonitor_list']) : '';

		// Mad Mimi

		$default_newsletter['madmimi']['api_key']                 = isset($_POST['madmimi_api_key']) ? sanitize_text_field($_POST['madmimi_api_key']) : '';

		$default_newsletter['madmimi']['username']                = isset($_POST['madmimi_username']) ? sanitize_text_field($_POST['madmimi_username']) : '';

		$default_newsletter['madmimi']['list']                    = isset($_POST['madmimi_list']) ? sanitize_text_field($_POST['madmimi_list']) : '';

		// Infusion Soft

		$default_newsletter['infusionsoft']['app_id']             = isset($_POST['infusionsoft_app_id']) ? sanitize_text_field($_POST['infusionsoft_app_id']) : '';

		$default_newsletter['infusionsoft']['api_key']            = isset($_POST['infusionsoft_api_key']) ? sanitize_text_field($_POST['infusionsoft_api_key']) : '';

		$default_newsletter['infusionsoft']['list']               = isset($_POST['infusionsoft_list']) ? sanitize_text_field($_POST['infusionsoft_list']) : '';

		// feedburner

		$default_newsletter['feedburner']['id']                   = isset($_POST['feedburner_id']) ? sanitize_text_field($_POST['feedburner_id']) : '';

		$result = update_option(NNRobots_Optin_Fire::$prefix . 'default_newsletter', $default_newsletter);

		if ( $result ) {
			echo __('Default newsletter was saved', NNRobots_Optin_Fire::$text_domain);
			die();
		} else {
			echo __('Default newsletter was not saved', NNRobots_Optin_Fire::$text_domain);
			die();
		}

		echo __('Default newsletter was not saved', NNRobots_Optin_Fire::$text_domain);
		die();
	}

	/**
	 * Save the send weekly email setting
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function send_weekly_email() {

		$global_settings = get_option(NNRobots_Optin_Fire::$prefix . 'global_settings');

		if ( $global_settings === false ) {
			$global_settings = self::default_global_settings();
		}

		if ($_POST['send_weekly_email'] == 'true') {
			$global_settings['send_weekly_email'] = true;
		} else {
			$global_settings['send_weekly_email'] = false;
		}

		update_option(NNRobots_Optin_Fire::$prefix . 'global_settings', $global_settings);

		echo '';
		die();
	}

	/**
	 * Generate a live preview for the user
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function live_preview() {

		if ( !isset($_POST['optin']) ) {
			echo __('Optin Data not found so we were unable to generate a live preview', NNRobots_Optin_Fire::$text_domain);
			die();
		}

		$optin_fire_preview = '';
		$optin = (array) $_POST['optin'];

		// Convery all string bools to just bools

		$optin = self::convertStringtoBool($optin);

		if ($optin['type'] == '5') {
			$optin_fire_preview = NNRobots_Optin_Fire_Functions::generate_code($optin, $optin['news_letter'], true);
		} else {
			$optin_fire_preview = NNRobots_Optin_Fire_Functions::generate_code($optin, $optin['news_letter']);
		}

		echo $optin_fire_preview;
		die();
	}

	/**
	 * Adds a new Optin and then returns its editing page url
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function add_new() {

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/model/db.php');

		$optin_fire = array_merge(self::default_optin_fire(), array(
			'name' => 'My Optin',
			'type' => $_POST['type']
		));

		// Banner

		if ($_POST['type'] == '1') {
			$optin_fire['style'] = array_merge($optin_fire['style'], array(
				'background_color'	=> '#ef5f00',
				'color'				=> '#ffffff',
				'nl_color'			=> '#ffffff',
				'nl_bg_color'		=> '#1e73be',
				'icon_color'		=> '#000000',
				'border_color'		=> '#000000',
			));
		}

		// Popup

		if ($_POST['type'] == '2') {
			$optin_fire['style'] = array_merge($optin_fire['style'], array(
				'background_color'	=> '#ffffff',
				'color'				=> '#333333',
				'nl_color'			=> '#ffffff',
				'nl_bg_color'		=> '#4FC000',
				'icon_color'		=> '#000000',
				'border_color'		=> '#4FC000',
			));
		}

		// Flyout

		if ($_POST['type'] == '3') {
			$optin_fire['style'] = array_merge($optin_fire['style'], array(
				'background_color'	=> '#ffffff',
				'color'				=> '#333333',
				'nl_color'			=> '#ffffff',
				'nl_bg_color'		=> '#ef5f00',
				'icon_color'		=> '#000000',
				'border_color'		=> '#ef5f00',
			));
		}

		// In Post Content / Widget

		if ($_POST['type'] == '4' && $_POST['type'] == '5') {
			$optin_fire['style'] = array_merge($optin_fire['style'], array(
				'background_color'	=> '#ffffff',
				'color'				=> '#333333',
				'nl_color'			=> '#ffffff',
				'nl_bg_color'		=> '#4FC000',
				'icon_color'		=> '#000000',
				'border_color'		=> '#4FC000',
			));
		}

		$default_newsletter = get_option(NNRobots_Optin_Fire::$prefix . 'default_newsletter');

		if ( false === $default_newsletter ) {
			$default_newsletter = array(
				'type'	=> 'wordpress',
			);
		}

		$default_optin_fire = self::default_optin_fire();

		$optin_fire['news_letter'] = array_merge($default_optin_fire['news_letter'], $default_newsletter);

		$nnrobots_optin_fire_db = new NNRobots_Optin_Fire_DB();
		$optin_fire_id = $nnrobots_optin_fire_db->add_data($optin_fire);

		echo get_admin_url() . 'admin.php?page=' .
			NNRobots_Optin_Fire::$add_new_page . '&optin_fire_id=' .
			$optin_fire_id . '&wp_nonce' .
			wp_create_nonce(NNRobots_Optin_Fire::$prefix . 'edit');

		die();

	}

	/**
	 * Change the status of the Optin
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function change_status(){

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/model/db.php');
		$nnrobots_optin_fire_db = new NNRobots_Optin_Fire_DB();
		$optin_fire = $nnrobots_optin_fire_db->get_data_from_id($_POST['optin_fire_id']);

		$nnrobots_optin_fire_db->set_active($_POST["optin_fire_id"], $_POST["status"]);

		// Check if optin fire is currently in an A/B Test

		if ( isset($optin_fire['args']['ab_testing']['active']) && $optin_fire['args']['ab_testing']['active'] &&
			 isset($optin_fire['args']['ab_testing']['is_variant']) && !$optin_fire['args']['ab_testing']['is_variant'] ) {

			 foreach ( $optin_fire['args']['ab_testing']['children'] as $key => $child ) {
			 	$nnrobots_optin_fire_db->set_active($child, $_POST["status"]);
			 }
		}

		echo '';
		die();
	}

	/**
	 * Deletes a new Optin and then returns its editing page url
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function remove() {

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/model/db.php');
		$nnrobots_optin_fire_db = new NNRobots_Optin_Fire_DB();
		$optin_fire = $nnrobots_optin_fire_db->get_data_from_id($_POST['optin_fire_id']);

		// Check if optin fire is currently in an A/B Test

		if ( isset($optin_fire['args']['ab_testing']['active']) && $optin_fire['args']['ab_testing']['active'] &&
			 $optin_fire['args']['ab_testing']['is_variant'] ) {

			$parent_optin_fire = $nnrobots_optin_fire_db->get_data_from_id($optin_fire['args']['ab_testing']['parent']);

			if ( isset($parent_optin_fire) ) {

				// Remove child from list

				foreach ( $parent_optin_fire['args']['ab_testing']['children'] as $key => $child ) {
					if ( $child == $optin_fire['id'] ) {
						unset($parent_optin_fire['args']['ab_testing']['children'][$key]);
					}
				}

				// If we just deleted the last variant then end test

				if ( count($parent_optin_fire['args']['ab_testing']['children']) == 0 ) {
					$parent_optin_fire['args']['ab_testing']['active']          = false;
					$parent_optin_fire['args']['ab_testing']['start_date']      = '0';
				}

				$nnrobots_optin_fire_db->update_data($parent_optin_fire);
			}
		}

		// Delete record

		if (isset($_POST["optin_fire_id"])) {
			$nnrobots_optin_fire_db->delete_data($_POST["optin_fire_id"]);
		}

		// Return the id

		echo json_encode(array(
			'id'	=> $_POST['optin_fire_id'],
		));

		die();

	}

	/**
	 * Duplicate an existing optin
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function duplicate() {

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/model/db.php');
		$nnrobots_optin_fire_db = new NNRobots_Optin_Fire_DB();
		$optin_fire = $nnrobots_optin_fire_db->get_data_from_id($_POST['optin_fire_id']);

		// Duplicate

		$new_optin_fire = $optin_fire;
		$new_optin_fire['name'] .= __(' Copy', NNRobots_Optin_Fire::$text_domain);
		$new_optin_fire_id = $nnrobots_optin_fire_db->add_data($new_optin_fire);

		// Return back new id

		echo json_encode(array(
			'id'	=> $new_optin_fire_id,
		));

		die();

	}

	/**
	 * Change the test status of the Optin
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function change_test_status() {

		if ( !isset($_POST['optin_fire_id']) ) {
			echo __('No parent id was found', NNRobots_Optin_Fire::$text_domain);
			die();
		}

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/model/db.php');

		$nnrobots_optin_fire_db       = new NNRobots_Optin_Fire_DB();
		$optin_fire                   = $nnrobots_optin_fire_db->get_data_from_id($_POST['optin_fire_id']);

		if ( isset($_POST['status']) && $_POST['status'] == 'pause') {
			$optin_fire['args']['ab_testing']['on'] = false;
		} else {
			$optin_fire['args']['ab_testing']['on'] = true;
		}

		$nnrobots_optin_fire_db->update_data($optin_fire);

		echo $_POST['optin_fire_id'];

		die();
	}

	/**
	 * Get all the setting to end a test
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_end_test_options() {

		if ( !isset($_POST['parent_id']) ) {
			echo __('No parent id was found', NNRobots_Optin_Fire::$text_domain);
			die();
		}

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/model/db.php');
		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'core/model/stats.php');

		$nnrobots_optin_fire_db       = new NNRobots_Optin_Fire_DB();
		$optin_fire                   = $nnrobots_optin_fire_db->get_data_from_id($_POST['parent_id']);

		// Create list of all optins and their data

		$end_test_optins = array();

		// Add parent to list

		$start_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, strtotime($optin_fire['args']['ab_testing']['start_date']));
		$stats = NNRobots_Stats_OF::getStats($start_date, null, $optin_fire['id']);

		$impressions_total = 0;
		$conversions_total = 0;
		foreach ($stats as $stat) {
		    $conversions_total += $stat['conversions'];
		    $impressions_total += $stat['impressions'];
		}
        $ctr = $impressions_total != 0 ? round(($conversions_total/$impressions_total) * 100, 2) : 0;

        $end_test_optins[] = array(
	    	'id'				=> $optin_fire['id'],
	    	'name'				=> $optin_fire['name'],
	    	'impressions'		=> $impressions_total,
	    	'conversions'		=> $conversions_total,
	    	'conversion_rate'	=> $ctr . '%',
        );

		// Add all children to list

		foreach ( $optin_fire['args']['ab_testing']['children'] as $child ) {

			$variant_optin_fire = $nnrobots_optin_fire_db->get_data_from_id($child);
			$stats = NNRobots_Stats_OF::getStats($start_date, null, $child);

			$impressions_total = 0;
			$conversions_total = 0;
			foreach ($stats as $stat) {
			    $conversions_total += $stat['conversions'];
			    $impressions_total += $stat['impressions'];
			}

	        $ctr = $impressions_total != 0 ? round(($conversions_total/$impressions_total) * 100, 2) : 0;

	        $end_test_optins[] = array(
		    	'id'				=> $child,
		    	'name'				=> $variant_optin_fire['name'],
		    	'impressions'		=> $impressions_total,
		    	'conversions'		=> $conversions_total,
		    	'conversion_rate'	=> $ctr . '%',
	        );

		}

		// Sort Table from highest conversions to lowest

		usort($end_test_optins, array('NNRobots_Optin_Fire_Admin_Functions', 'sortByConversions'));

		// Create table

		$settings = '<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'end-test-data">
		<p>' . __('Pick the winner of this test by selecting the checkmark next to its name.  We have already selected the best performing Optin for you based on conversion rate.', NNRobots_Optin_Fire:: $text_domain) . '</p>
		<table class="table">
			<thead>
				<tr>
					<th></th>
					<th>' . __('Pick', NNRobots_Optin_Fire::$text_domain) . '</th>
					<th>' . __('Name', NNRobots_Optin_Fire::$text_domain) . '</th>
					<th>' . __('Impressions *', NNRobots_Optin_Fire::$text_domain) . '</th>
					<th>' . __('Conversions *', NNRobots_Optin_Fire::$text_domain) . '</th>
					<th>' . __('Conversion Rate *', NNRobots_Optin_Fire::$text_domain) . '</th>
				</tr>
			</thead>
			<tbody>';

		foreach ( $end_test_optins as $key => $end_test_optin ) {
			//' . ($key == 0 ? 'style="background-color:#ecf6fd;"' : '') . '
			$settings .= '<tr>
					<td>' . ($key == 0 ? '<span class="fa-stack fa-lg">
					  <i style="color:#ddd;" class="fa fa-sun-o fa-stack-2x"></i>
					  <i style="color:#f15928;" class="fa fa-stack-1x fa-trophy"></i>
					</span>' : '') . '</td>
					<td>
						<input type="radio" name="' . NNRobots_Optin_Fire::$prefix_dash . 'optin-fire-chosen" value="' . $end_test_optin['id'] . '" ' . ($key == 0 ? 'checked="checked"' : '') . '/>
						<label>
				            <span class="fa-stack fa-lg">
				                <i class="fa fa-square-o fa-stack-1x"></i>
				                <i class="fa fa-check fa-stack-1x"></i>
				            </span>
				        </label>
					</td>

					<td>' . $end_test_optin['name'] . '</td>
					<td>' . $end_test_optin['impressions'] . '</td>
					<td>' . $end_test_optin['conversions'] . '</td>
					<td class="conversions column-conversions" data-defaultsort="desc" data-value="' . rtrim($end_test_optin['conversion_rate'],'%') . '">' . $end_test_optin['conversion_rate'] . '</td>
				</tr>';
		}

		$settings .= '</tbody>
	    </table>
	    <em style="font-size: 12px;" class="text-muted">* ' . __('Please note that all stats data is collected from the start of the A/B test on ' . date('M d, Y', strtotime($optin_fire['args']['ab_testing']['start_date'])) . '. Any data before that data will not be shown here.', NNRobots_Optin_Fire::$text_domain) . '</em>
	    </div>';

		echo $settings;

		die();

	}

	/**
	 * Sort End Test array by converions
	 *
	 * @access public
	 * @param mixed $a
	 * @param mixed $b
	 * @return void
	 */
	static function sortByConversions($a, $b) {
	    return $b['conversions'] - $a['conversions'];
	}

	/**
	 * Ends the A/B Test and deactivates all optins except for the winner
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function end_test() {

		// Check if parameters are set

		if ( !isset($_POST['parent_id']) ) {
			echo __('No parent id was found', NNRobots_Optin_Fire::$text_domain);
			die();
		}

		if ( !isset($_POST['chosen_id']) ) {
			echo __('No optin id was found', NNRobots_Optin_Fire::$text_domain);
			die();
		}

		// Include database controller

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/model/db.php');
		$nnrobots_optin_fire_db 			 = new NNRobots_Optin_Fire_DB();
		$parent_optin_fire 					 = $nnrobots_optin_fire_db->get_data_from_id($_POST['parent_id']);

		// Parent is winner

		if ( $_POST['chosen_id'] == $parent_optin_fire['id'] ) {

			// Loop through all children and set ab testing to false and make inactive

			foreach ( $parent_optin_fire['args']['ab_testing']['children'] as $child ) {

				// Get the child optin

				$child_optin_fire                                       = $nnrobots_optin_fire_db->get_data_from_id($child);

				// Reset all ab testing settings

				$child_optin_fire['active']							    = 'Inactive';
				$child_optin_fire['args']['ab_testing']['start_date']   = '';
				$child_optin_fire['args']['ab_testing']['children']     = array();
				$child_optin_fire['args']['ab_testing']['active']       = false;
				$child_optin_fire['args']['ab_testing']['on']           = false;
				$child_optin_fire['args']['ab_testing']['is_variant']   = false;
				$child_optin_fire['args']['ab_testing']['next']         = null;

				// Update optin

				$nnrobots_optin_fire_db->update_data($child_optin_fire);

			}

			// Remove all references to ab testing

			$parent_optin_fire['args']['ab_testing']['start_date']   = '';
			$parent_optin_fire['args']['ab_testing']['children']     = array();
			$parent_optin_fire['args']['ab_testing']['active']       = false;
			$parent_optin_fire['args']['ab_testing']['on']           = false;
			$parent_optin_fire['args']['ab_testing']['is_variant']   = false;
			$parent_optin_fire['args']['ab_testing']['next']   		 = null;

			$nnrobots_optin_fire_db->update_data($parent_optin_fire);

		}

		// Variant is winner

		else {

			// Loop through all children and set ab testing to false and make inactive

			foreach ( $parent_optin_fire['args']['ab_testing']['children'] as $child ) {

				// Get the child optin

				$child_optin_fire                                       = $nnrobots_optin_fire_db->get_data_from_id($child);

				// Reset all ab testing settings

				if ( $child_optin_fire['id'] == $_POST['chosen_id'] ) {
					$child_optin_fire['active']							= 'Active';
				} else {
					$child_optin_fire['active']							= 'Inactive';
				}

				$child_optin_fire['args']['ab_testing']['start_date']   = '';
				$child_optin_fire['args']['ab_testing']['children']     = array();
				$child_optin_fire['args']['ab_testing']['active']       = false;
				$child_optin_fire['args']['ab_testing']['on']           = false;
				$child_optin_fire['args']['ab_testing']['is_variant']   = false;
				$child_optin_fire['args']['ab_testing']['next']         = null;

				// Update optin

				$nnrobots_optin_fire_db->update_data($child_optin_fire);

			}

			// Remove all references to ab testing

			$parent_optin_fire['active']							 = 'Inactive';
			$parent_optin_fire['args']['ab_testing']['start_date']   = '';
			$parent_optin_fire['args']['ab_testing']['children']     = array();
			$parent_optin_fire['args']['ab_testing']['active']       = false;
			$parent_optin_fire['args']['ab_testing']['on']           = false;
			$parent_optin_fire['args']['ab_testing']['is_variant']   = false;
			$parent_optin_fire['args']['ab_testing']['next']   		 = null;

			$nnrobots_optin_fire_db->update_data($parent_optin_fire);

		}

		echo __('Test has been ended.', NNRobots_Optin_Fire::$text_domain);

		die();

	}

	/**
	 * Add new variant for testing.  If this is the first variant then an ab test will be created
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function add_variant() {

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/model/db.php');
		$nnrobots_optin_fire_db 			 = new NNRobots_Optin_Fire_DB();
		$parent_optin_fire 					 = $nnrobots_optin_fire_db->get_data_from_id($_POST['optin_fire_id']);

		// Create new optin with same settings as current one.

		$varient_name = $parent_optin_fire['name'] . __(' Variant', NNRobots_Optin_Fire::$text_domain);

		if ( isset($parent_optin_fire['args']['ab_testing']['children']) &&
			 is_array($parent_optin_fire['args']['ab_testing']['children']) ) {
			 $varient_name .= ' ' . (count($parent_optin_fire['args']['ab_testing']['children']) + 1);
		}

		$variant_optin_fire                                       = $parent_optin_fire;
		$variant_optin_fire['type']                               = $_POST['type'];
		$variant_optin_fire['name']                               = $varient_name;
		$variant_optin_fire['args']['ab_testing']['active']       = true;
		$variant_optin_fire['args']['ab_testing']['on']       	  = true;
		$variant_optin_fire['args']['ab_testing']['is_variant']   = true;
		$variant_optin_fire['args']['ab_testing']['parent']       = $parent_optin_fire['id'];
		$variant_optin_fire['args']['ab_testing']['start_date']   = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT);

		// CTA Type

		if ( $parent_optin_fire['type'] == '2' && $_POST['type'] != '2' && $parent_optin_fire['template']['args']['call_to_action'] == 'video' ) {
			$variant_optin_fire['template']['args']['call_to_action'] = 'none';
		}

		if ( $parent_optin_fire['type'] != '1' && $_POST['type'] == '1' && $parent_optin_fire['template']['args']['call_to_action'] == 'clickable-image' ) {
			$variant_optin_fire['template']['args']['call_to_action'] = 'none';
		}

		$variant_optin_fire_id = $nnrobots_optin_fire_db->add_data($variant_optin_fire);

		// Add variant parent optin

		if ( !isset($parent_optin_fire['args']['ab_testing']['children']) ||
			 !is_array($parent_optin_fire['args']['ab_testing']['children']) ||
			 count($parent_optin_fire['args']['ab_testing']['children']) == 0 ) {

			$parent_optin_fire['args']['ab_testing']['start_date']   = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT);
			$parent_optin_fire['args']['ab_testing']['children']     = array();
			$parent_optin_fire['args']['ab_testing']['active']       = true;
			$parent_optin_fire['args']['ab_testing']['on']           = true;
			$parent_optin_fire['args']['ab_testing']['is_variant']   = false;
		}

		$parent_optin_fire['args']['ab_testing']['children'][] 	= $variant_optin_fire_id;

		if ( isset($_POST['name']) ) {
			$parent_optin_fire['args']['ab_testing']['name'] 	    = $_POST['name'];
		}

		$nnrobots_optin_fire_db->update_data($parent_optin_fire);

		// Send back edit page link

		echo get_admin_url() . 'admin.php?page=' .
			NNRobots_Optin_Fire::$add_new_page . '&optin_fire_id=' .
			$variant_optin_fire_id . '&wp_nonce' .
			wp_create_nonce(NNRobots_Optin_Fire::$prefix . 'edit');

		die();

	}

	/**
	 * Start or Stop an A/B Test
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function ab_test() {

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . 'admin/model/db.php');
		$nnrobots_optin_fire_db = new NNRobots_Optin_Fire_DB();

		$optin_fire = $nnrobots_optin_fire_db->get_data_from_id($_POST['optin_fire_id']);

		if ($_POST['status'] == 'start') {

			$optin_fire['args']['ab_testing']['active'] = true;
			$optin_fire['args']['ab_testing']['start_date'] = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT);

			// Create new optin_fire with same settings as current one.

			$ab_optin_fire = $optin_fire;
			$ab_optin_fire['name'] .= ' A/B Testing';
			$ab_optin_fire['args']['ab_testing']['active'] = true;
			$ab_optin_fire['args']['ab_testing']['optin_fire_id'] = $optin_fire['id'];
			$ab_optin_fire['args']['ab_testing']['start_date'] = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT);
			$ab_optin_fire_id = $nnrobots_optin_fire_db->add_data($ab_optin_fire);

			$optin_fire['args']['ab_testing']['optin_fire_id'] = $ab_optin_fire_id;

		} else if ($_POST['status'] == 'stop') {

			$ab_optin_fire_id = $optin_fire['args']['ab_testing']['optin_fire_id'];

			$optin_fire['args']['ab_testing']['active'] = false;
			$ab_optin_fire = $nnrobots_optin_fire_db->get_data_from_id($optin_fire['args']['ab_testing']['optin_fire_id']);
			$optin_fire['args']['ab_testing']['optin_fire_id'] = '0';
			$optin_fire['args']['ab_testing']['start_date'] = '';

			if (isset($ab_optin_fire)) {

				$ab_optin_fire['args']['ab_testing']['active'] = false;
				$ab_optin_fire['args']['ab_testing']['optin_fire_id'] = '0';
				$ab_optin_fire['args']['ab_testing']['start_date'] = '';
				$nnrobots_optin_fire_db->update_data($ab_optin_fire);
			}

		}

		$nnrobots_optin_fire_db->update_data($optin_fire);

		echo json_encode(array(
			'id'	=> $ab_optin_fire_id,
		));
		die();
	}

	/**
	 * convertStringtoBool function.
	 *
	 * @access public
	 * @static
	 * @param mixed $data
	 * @return void
	 */
	static function convertStringtoBool( $data ) {

		// Convert a string

		if ( !is_array($data) ) {
			if ( $data == 'true' ) {
				return true;
			} else if ( $data == 'false' ) {
				return false;
			}
		}

		// Convert all strings in an array

		foreach ( $data as $key => $value ) {

			if ( $value == 'true' ) {
				$data[$key] = true;
			} else if ( $value == 'false' ) {
				$data[$key] = false;
			}

			// Check if nested array and pefrom recursion

			if ( is_array($value) ) {
				$data[$key] = self::convertStringtoBool($value);
			}

		}

		return $data;

	}

	/**
	 * Checks for element in multidimentional aray
	 *
	 * @access public
	 * @static
	 * @param mixed $needle
	 * @param mixed $haystack
	 * @param bool $strict (default: false)
	 * @return void
	 */
	static function in_array_r($needle, $haystack, $strict = false) {
	    foreach ($haystack as $item) {
	        if (($strict ? $item === $needle : $item == $needle) || (is_array($item) && self::in_array_r($needle, $item, $strict))) {
	            return true;
	        }
	    }

	    return false;
	}
}

//endif;